#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Je2Mots.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Logiciel gratuit dvelopp en AutoIt
#AutoIt3Wrapper_Res_Description=Je 2 Mots
#AutoIt3Wrapper_Res_Fileversion=1.1.0.4
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs -----------------------------------------------------------------------------------------------

	Je2Mots
	Script AutoIt Version 3.3.8.0

	Auteur : Ahbadiane
	Dcembre 2011 - Janvier 2012

	EN CHANTIER :

	BUG :

	A FAIRE :

	FAIT :

#ce -----------------------------------------------------------------------------------------------

#Region - Dclaration ---------------------------------------------------------
#Include "_DicoDefinition.au3"
#Include <EditConstants.au3>
#Include <GuiComboBox.au3>
#Include <GUIConstantsEx.au3>
#Include <GuiListView.au3>
#Include <Math.au3>
#Include <ProgressConstants.au3>
#Include <SQLite.au3>
#Include <StaticConstants.au3>
#Include <WindowsConstants.au3>

AutoItSetOption("MustDeclareVars", 1)
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
#EndRegion - Dclaration ------------------------------------------------------


#Region - Dfinition Variables ------------------------------------------------
Global Const $scVersion = _NumVersion(@ScriptFullPath)
Global $sFenetreTitre = "Je 2 Mots v" & _NumVerCourt($scVersion) & " by Ahbadiane"
Global $FormJe2Mots ; Handle de la fentre principale
Global Const $scFicDB = @ScriptDir & "\Je2Mots.db"
Global Const $iFormTop = _EspaceBureau(1), $iFormHeight = _EspaceBureau(3) - $iFormTop -40
Global $sGererDicoSqlCount
Global Const $scLettreOK = "abcdefghijklmnopqrstuvwxyz"
Global $hDbDico, $sMsg, $bDoubleClicItem = False
Global $hDllUser32 ; Handle de la Dll user32 utilis par _IsPressed
; Paramtres en base
Global $sStrategieDeRecherche, $bEnregistrerRechercheEnBase, $bChercherEnBase
#EndRegion - Dfinition Variables ---------------------------------------------


Je2Mots()
Exit


#Region - Interface Principale ------------------------------------------------
Func Je2Mots()
	$hDllUser32 = DllOpen("user32.dll")
	If $hDllUser32 = -1 Then
		_Message("E", "La DLL User32 ne peut pas tre ouverte !")
		Exit
	EndIf
	Local Const $iWinLargeur = 406, $iWinHauteur = 244
	$FormJe2Mots = GUICreate($sFenetreTitre, $iWinLargeur, $iWinHauteur, -1, -1)
	GUISetFont(9, 800, 0, "Verdana")
	Local $Graphic = GUICtrlCreateGraphic(0, 0, $iWinLargeur, $iWinHauteur)
	GuiCtrlSetState($Graphic, $GUI_DISABLE)
	_VGradientFill($Graphic, 0, 0, $iWinLargeur, $iWinHauteur - 20, _ArrayCreate(180,98,07), _ArrayCreate(255,255,255))
	GUICtrlSetGraphic($Graphic, $GUI_GR_REFRESH)
	Local $ButtonAnagrammeSimple = GUICtrlCreateButton("Anagramme simple", 16, 16, 180, 40)
	Local $ButtonMotMystere = GUICtrlCreateButton("Mot mystre", 210, 16, 180, 40)
	Local $ButtonAnagrammeMulti = GUICtrlCreateButton("Anagramme multi-mots", 16, 68, 180, 40)
	Local $ButtonLettrePlacee = GUICtrlCreateButton("Lettres places", 210, 68, 180, 40)
	Local $ButtonDefinition = GUICtrlCreateButton("Dfinition", 16, 120, 180, 40)
	Local $ButtonGererDico = GUICtrlCreateButton("Grer votre dictionnaire", 210, 120, 180, 40)
	Local $ButtonReglage = GUICtrlCreateButton("Rglages", 16, 172, 180, 25)
	Local $ButtonQuitter = GUICtrlCreateButton("Quitter", 210, 172, 180, 25)
	GUICtrlCreateLabel("Un double clic sur toutes les listes affiche la dfinition du mot", 0, $iWinHauteur - 32, $iWinLargeur, 25, $SS_CENTER)
	GUICtrlSetColor(-1, 0xB6D1F7)
	GUICtrlSetFont(-1, 7, 400)
	Local $LabelNbMots = GUICtrlCreateLabel("", 0, $iWinHauteur - 18, $iWinLargeur, 25, $SS_CENTER)
	GUICtrlSetColor(-1, 0x99B4D1)
	GUICtrlSetFont(-1, 8, 400)
	GUISetState(@SW_SHOW, $FormJe2Mots)
	If Not _OuvrirDicoEtLectureParametres($FormJe2Mots) Then Exit
	GUICtrlSetData($LabelNbMots, _DicoNbTousMots(True))
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonQuitter
				ExitLoop
			Case $ButtonAnagrammeSimple
				AnagrammeSimple()
			Case $ButtonMotMystere
				MotMystere()
			Case $ButtonAnagrammeMulti
				AnagrammeMulti()
			Case $ButtonLettrePlacee
				LettrePlacee()
			Case $ButtonDefinition
				GererDefinition()
			Case $ButtonGererDico
				GererDico()
				GUICtrlSetData($LabelNbMots, _DicoNbTousMots(True))
			Case $ButtonReglage
				ReglagesAplli()
		EndSwitch
		Sleep(10)
	WEnd
	_FermerDico()
	DllClose($hDllUser32)
EndFunc
#EndRegion - Interface Principale ---------------------------------------------


#Region - Dfinition ----------------------------------------------------------
Func GererDefinition()
	Local Const $iMaxAuto = 20
	Local Const $sTip = "Vous pouvez utiliser des jokers pour afficher la liste :" & @CRLF & "? pour remplacer un seul caractres inconnu" & @CRLF & _
						"* pour remplacer un ou plusieurs caractres de suite inconnus" & @CRLF & _
						". (un point) en fin de mot pour indiquer que le mot se termine par la lettre prcdant le point"
	Local $sMotEnCours, $iaIndices, $iMinLongMot, $iMaxLongMot
	Local $hQuery, $saData, $sSql, $iNbLigne
	Local $FormGererDefinition = GUICreate("Recherche des dfinitions", 715, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	GUISetFont(8, 800, 0, "Verdana")
	GUICtrlCreateLabel("Mot recherch", 16, 16, 86, 17)
	GUICtrlSetTip(-1, $sTip)
	Local $InputMot = GUICtrlCreateInput("", 102, 12, 237, 21)
	GUICtrlSetFont(-1, 9)
	GUICtrlSetTip(-1, $sTip)
	GUICtrlCreateLabel("Longueur du mot, entre", 349, 16, 140, 17)
	GUICtrlSetFont(-1, 8, 400)
	Local $InputMotMin = GUICtrlCreateInput("1", 486, 12, 21, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_RIGHT,$ES_NUMBER))
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateLabel("et", 512, 16, 16, 17)
	GUICtrlSetFont(-1, 8, 400)
	Local $InputMotMax = GUICtrlCreateInput("25", 530, 12, 21, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_RIGHT,$ES_NUMBER))
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateLabel("lettres", 554, 16, 37, 17)
	GUICtrlSetFont(-1, 8, 400)
	Local $ListViewProposition = GUICtrlCreateListView("X", 102, 33, 237, $iMaxAuto * 18 +4, BitOR($LVS_NOCOLUMNHEADER, $LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	_GUICtrlListView_SetColumnWidth($ListViewProposition, 0, 230)
	GUICtrlSetFont(-1, 9, 400)
	GUICtrlSetState($ListViewProposition, $GUI_HIDE)
	Local $ButtonChercherDef = GUICtrlCreateButton("Rechercher", 596, 10, 100, 25)
	Local $LabelDico = GUICtrlCreateLabel("", 16, 39, 680, 15)
	GUICtrlSetColor(-1, 0x3399FF)
	GUICtrlSetBkColor(-1, 0xE5F3FF)
	Local $LabelDef = GUICtrlCreateLabel("", 16, 61, 680, $iFormHeight -100)
	GUICtrlSetColor(-1, 0x505050)
	GUICtrlSetBkColor(-1, 0xE5F3FF)
	Local $ButtonClipBoard = GUICtrlCreateButton("Copier dans le presse-papier", 16, $iFormHeight -31, 200, 25)
	Local $ButtonFermer = GUICtrlCreateButton("Fermer", 538, $iFormHeight -31, 170, 25)
	GUICtrlSetState($InputMot, $GUI_FOCUS)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	While 1
		If BitAND(GUICtrlGetState($ListViewProposition), $GUI_SHOW) And (ControlGetFocus($FormGererDefinition) = "Edit1") And _IsPressed("28", $hDllUser32) Then GUICtrlSetState($ListViewProposition, $GUI_FOCUS)
		If (ControlGetFocus($FormGererDefinition) = "SysListView321") And _IsPressed("0D", $hDllUser32) Then $bDoubleClicItem = True
		If $bDoubleClicItem Then
			$bDoubleClicItem = False
			$iaIndices = _GUICtrlListView_GetSelectedIndices($ListViewProposition, True)
			If $iaIndices[0] >= 1 Then
				GUICtrlSetData($InputMot, _GUICtrlListView_GetItemText($ListViewProposition, $iaIndices[1]))
				GUICtrlSetState($ListViewProposition, $GUI_HIDE)
			EndIf
		EndIf
		If ($sMotEnCours <> GUICtrlRead($InputMot)) Or ($iMinLongMot <> Number(GUICtrlRead($InputMotMin))) Or ($iMaxLongMot <> Number(GUICtrlRead($InputMotMax))) Then
			$sMotEnCours = GUICtrlRead($InputMot)
			$iMinLongMot = Number(GUICtrlRead($InputMotMin))
			$iMaxLongMot = Number(GUICtrlRead($InputMotMax))
			If $sMotEnCours = "" Then
				If BitAND(GUICtrlGetState($ListViewProposition), $GUI_SHOW) Then GUICtrlSetState($ListViewProposition, $GUI_HIDE)
			Else
				$sSql = StringReplace($sMotEnCours, "*", "%")
				$sSql = StringReplace($sSql, "?", "_")
				If StringRight($sSql, 1) = "." Then
					$sSql = StringTrimRight($sSql, 1)
				Else
					$sSql &= "%"
				EndIf
				$sSql = "SELECT DicoMot FROM Dico Where DicoMot Like '" & $sSql & "' And Length(DicoMot) >= " & $iMinLongMot & " And Length(DicoMot) <= " & $iMaxLongMot & " ORDER BY DicoMot LIMIT " & $iMaxAuto & ";"
				_SQlite_Query($hDbDico, $sSql, $hQuery)
				$iNbLigne = 0
				_GUICtrlListView_DeleteAllItems($ListViewProposition)
				If BitAND(GUICtrlGetState($ListViewProposition), $GUI_HIDE) Then GUICtrlSetState($ListViewProposition, $GUI_SHOW)
				While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
					GUICtrlCreateListViewItem($saData[0], $ListViewProposition)
					$iNbLigne += 1
				WEnd
				_SQLite_QueryFinalize($hQuery)
				_GUICtrlListView_SetItemSelected($ListViewProposition, 0)
				_GUICtrlListView_EnsureVisible($ListViewProposition, 0)
				If $iNbLigne = 0 Then
					GUICtrlSetState($ListViewProposition, $GUI_HIDE)
				Else
					ControlMove($FormGererDefinition, "", $ListViewProposition, 102, 33, 237, $iNbLigne * 18 +4)
				EndIf
			EndIf
		EndIf
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFermer
				ExitLoop
			Case $ButtonChercherDef
				$sMotEnCours = GUICtrlRead($InputMot)
				If StringInStr($sMotEnCours, "%") Or StringInStr($sMotEnCours, "?") Or StringInStr($sMotEnCours, "_") Or StringInStr($sMotEnCours, "*")  Or StringInStr($sMotEnCours, ".") Then
					_Message("E", "Le mot recherch ne peut pas contenir de joker." & @CRLF & "Ces jokers sont utiliss pour affiner la liste.", $FormGererDefinition)
				Else
					GUICtrlSetState($ListViewProposition, $GUI_HIDE)
					GUICtrlSetData($LabelDef, "")
					GUICtrlSetData($LabelDico, "")
					DefinitionAffichageEtEnregistrement($sMotEnCours, $FormGererDefinition, $LabelDico, $LabelDef)
				EndIf
			Case $ButtonClipBoard
				GUICtrlSetState($ListViewProposition, $GUI_HIDE)
				_DefClipBoard(GUICtrlRead($InputMot), GUICtrlRead($LabelDico), GUICtrlRead($LabelDef), $FormGererDefinition)
		EndSwitch
		Sleep(10)
	WEnd
	GUIDelete($FormGererDefinition)
	GUISetState(@SW_SHOW, $FormJe2Mots)
EndFunc
#EndRegion - Lettres places --------------------------------------------------


#Region - Lettres places -----------------------------------------------------
Func LettrePlacee()
	Local $sMsg, $i, $s, $iPos, $iIndice, $iMin, $iMax, $iVoirDetail = $GUI_HIDE
	Local $bOk, $iNbLettreTotal, $iNbLettreRestant, $sTexteTotalMin, $iValTotalMin, $sTexteTotalMax, $iValTotalMax, $iNbLigne
	Local $LabelLettre[27], $iCouleurLettre[27], $InputLettre[27], $LabelTous[4]
	Local $InputLettreplacee[27], $sLettrePlacee[27][2] ;[0]=Liste des champs, [1]=Nombre de lettre de A  Z
	Local $sTexteColonne = "Liste mots possibles"
	Local $FormLettrePLacee = GUICreate("Lettres places", 715, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	For $i = 1 To 26
		$InputLettreplacee[$i] = GUICtrlCreateInput("", 8, 8, 24, 22, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER, $ES_UPPERCASE))
		GUICtrlSetFont(-1, 12, 800, 0, "Verdana")
		GUICtrlSetLimit(-1, 1)
		GUICtrlSetState(-1, $GUI_HIDE)
	Next
	Local $LabelNbLettre = GUICtrlCreateLabel("Placer les lettres connues ici", 8, 12, 80, 30, $SS_CENTER)
	GUICtrlCreateLabel("Nombre de lettres du mot", 270, 42, 120, 15)
	Local $InputNbLettre = GUICtrlCreateInput("10", 411, 38, 46, 23, BitOR($ES_CENTER, $ES_NUMBER))
	GUICtrlSetFont(-1, 11, 800)
	GUICtrlSetLimit(-1, 2)
	GUICtrlSetBkColor(-1, 0x0096FF)
	GUICtrlCreateUpdown(-1)
	LettrePlacee_AfficheLettrePlacee($InputLettreplacee, $LabelNbLettre, Number(GUICtrlRead($InputNbLettre)), $FormLettrePLacee)
	Local $ButtonDetail = GUICtrlCreateButton("+ de dtails", 640, 41, 68, 21)
	GUICtrlCreateLabel("Pour les lettres manquantes", 270, 66, 136, 15)
	$LabelTous[1] = GUICtrlCreateLabel("Lettre carte", 611, 66, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0xFF0000)
	$LabelTous[2] = GUICtrlCreateLabel("Lettre factutative", 511, 66, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0xFFB000)
	$LabelTous[3] = GUICtrlCreateLabel("Lettre obligatoire", 411, 66, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0x00FF00)
	$iPos = 8
	For $i = 65 To 90
		$LabelLettre[$i -64] = GUICtrlCreateLabel(Chr($i), $iPos, 87, 24, 22, BitOR($SS_CENTER, $WS_BORDER))
		GUICtrlSetFont(-1, 12, 800, 0, "Verdana")
		$iCouleurLettre[$i -64] = 2
		LettrePlacee_CouleurMinMax($i -64, $iCouleurLettre, $LabelLettre, $InputLettre, True)
		$iPos += 27
	Next
	$iPos = 8
	For $i = 65 To 90
		$InputLettre[$i -64] = GUICtrlCreateInput("0-N", $iPos -1, 110, 26, 20, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER))
		GUICtrlSetFont(-1, 8, 400, 0, "Calibri")
		GUICtrlSetState(-1, $GUI_HIDE)
		$iCouleurLettre[$i -64] = 1
		$iPos += 27
	Next
	Local $ButtonRechercherStopper = GUICtrlCreateButton("Valider cette recherche", 542, 134, 170, 25)
	Local $ListViewLettrePlacee = GUICtrlCreateListView($sTexteColonne, 181, 134, 352, $iFormHeight -140, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	_GUICtrlListView_SetColumnWidth($ListViewLettrePlacee, 0, 329)
	Local $ButtonSave = GUICtrlCreateButton("Enregistrer dans un fichier", 542, $iFormHeight -89, 170, 25)
	Local $ButtonClipBoard = GUICtrlCreateButton("Enregistrer dans le presse-papier", 542, $iFormHeight -60, 170, 25)
	Local $ButtonFermer = GUICtrlCreateButton("Fermer", 542, $iFormHeight -31, 170, 25)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	While 1
		$sMsg = GUIGetMsg()
		$s = ControlGetFocus($FormLettrePLacee)
		If StringLeft($s, 4) = "Edit" Then
			$iIndice = Number(StringMid($s, 5))
			$iNbLettreTotal = Number(GUICtrlRead($InputNbLettre))
			If ($iIndice > 0) And ($iIndice <= $iNbLettreTotal) Then
				$s = StringLower(GUICtrlRead($InputLettreplacee[$iIndice]))
				If $s <> $sLettrePlacee[$iIndice][0] Then
					$sLettrePlacee[$iIndice][0] = $s
					If $s = " " Then GUICtrlSetData($InputLettreplacee[$iIndice], "")
					If ($iIndice +1) <= $iNbLettreTotal Then GUICtrlSetState($InputLettreplacee[$iIndice +1], $GUI_FOCUS)
				EndIf
			EndIf
		Else
			Sleep(30)
		EndIf
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFermer
				ExitLoop
			Case $InputLettreplacee[1] To $InputLettreplacee[26]
				$iIndice = $sMsg - $InputLettreplacee[1] +1
				$s = StringStripWS(GUICtrlRead($InputLettreplacee[$iIndice]), 8)
				If ($s <> "") And Not StringInStr($scLettreOK, $s) Then
					_Message("E", "Lettre '" & $s & "' interdite", $FormLettrePLacee)
					GUICtrlSetState($InputLettreplacee[$iIndice], $GUI_FOCUS)
				EndIf
			Case $LabelLettre[1] To $LabelLettre[26]
				$iIndice = $sMsg - $LabelLettre[1] +1
				$iCouleurLettre[$iIndice] += 1
				If $iCouleurLettre[$iIndice] > 3 Then $iCouleurLettre[$iIndice] = 1
				LettrePlacee_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, True)
			Case $InputLettre[1] To $InputLettre[26]
				$iIndice = $sMsg - $InputLettre[1] +1
				$s = LettrePlacee_LettreMinMax(GUICtrlRead($InputLettre[$iIndice]), $iMin, $iMax)
				If $s = "" Then
					$iCouleurLettre[$iIndice] = 4
					LettrePlacee_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, False)
					GUICtrlSetState($sMsg, $GUI_FOCUS)
				Else
					GUICtrlSetData($sMsg, $s)
					If ($iMin = 0) And (String($iMax) = "0") Then
						$iCouleurLettre[$iIndice] = 1
					ElseIf String($iMin) = "0" Then
						$iCouleurLettre[$iIndice] = 2
					Else
						$iCouleurLettre[$iIndice] = 3
					EndIf
					LettrePlacee_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, False)
				EndIf
			Case $LabelTous[1] To $LabelTous[3]
				$iPos = $sMsg - $LabelTous[1] +1
				For $i = 1 To 26
					$iCouleurLettre[$i] = $iPos
					LettrePlacee_CouleurMinMax($i, $iCouleurLettre, $LabelLettre, $InputLettre, True)
				Next
			Case $InputNbLettre
				$iNbLettreTotal = Number(GUICtrlRead($InputNbLettre))
				If ($iNbLettreTotal > 25) Or ($iNbLettreTotal < 2) Then
					_Message("E", "Le nombre de lettres doit tre compris entre 2 et 25", $FormLettrePLacee)
					GUICtrlSetState($InputNbLettre, $GUI_FOCUS)
				Else
					LettrePlacee_AfficheLettrePlacee($InputLettreplacee, $LabelNbLettre, $iNbLettreTotal, $FormLettrePLacee)
				EndIf
			Case $ButtonSave
				_ListViewSaveTxt($sTexteColonne, "LettresPlacees_" & Number(GUICtrlRead($InputNbLettre)) & "_Lettres.txt", $ListViewLettrePlacee, $FormLettrePLacee)
			Case $ButtonClipBoard
				_ListViewClipPut($sTexteColonne, $ListViewLettrePlacee, $FormLettrePLacee)
			Case $ButtonDetail
				If $iVoirDetail = $GUI_HIDE Then
					$iVoirDetail = $GUI_SHOW
					GUICtrlSetData($ButtonDetail, "- de dtails")
				Else
					$iVoirDetail = $GUI_HIDE
					GUICtrlSetData($ButtonDetail, "+ de dtails")
					For $i = 1 To 26
						Switch $iCouleurLettre[$i]
							Case 1 ; Rouge
								GUICtrlSetData($InputLettre[$i], "0-0")
							Case 2 ; Orange
								GUICtrlSetData($InputLettre[$i], "0-N")
							Case 3 ; Vert
								GUICtrlSetData($InputLettre[$i], "1-N")
						EndSwitch
					Next
				EndIf
				For $i = 1 To 26
					GUICtrlSetState($InputLettre[$i], $iVoirDetail)
				Next
			Case $ButtonRechercherStopper
				$bOk = True
				$iNbLettreTotal = Number(GUICtrlRead($InputNbLettre))
				If ($iNbLettreTotal > 25) Or ($iNbLettreTotal < 2) Then
					_Message("E", "Le nombre de lettres doit tre compris entre 2 et 25", $FormLettrePLacee)
					GUICtrlSetState($InputNbLettre, $GUI_FOCUS)
					$bOk = False
				EndIf
				If $bOk Then
					Dim $sLettrePlacee[27][2]
					$iNbLettreRestant = $iNbLettreTotal
					For $i = 1 To $iNbLettreTotal
						$s = StringLower(StringStripWS(GUICtrlRead($InputLettreplacee[$i]), 8))
						$sLettrePlacee[$i][0] = $s
						If ($s >="a") And ($s <= "z") Then
							$sLettrePlacee[Asc($s) -96][1] += 1
							$iNbLettreRestant -= 1
						EndIf
					Next
					If $iNbLettreRestant = 0 Then
						_Message("E", "Il n'y a rien  rechercher puisque vous avez plac les " & $iNbLettreTotal & " lettres", $FormLettrePLacee)
						$bOk = False
					EndIf
				EndIf
				If $bOK Then
					$sTexteTotalMin = ""
					$iValTotalMin = 0
					$sTexteTotalMax = ""
					$iValTotalMax = 0
					For $i = 1 To 26
						If LettrePlacee_LettreMinMax(GUICtrlRead($InputLettre[$i]), $iMin, $iMax) = "" Then
							_Message("E", "La lettre " & Chr($i +64) & " est mal dfinie", $FormLettrePLacee)
							GUICtrlSetState($InputLettre[$i], $GUI_FOCUS)
							$bOk = False
							ExitLoop
						EndIf
						If $iMin > 0 Then
							$iValTotalMin += $iMin
							$sTexteTotalMin &= $iMin & Chr($i + 64) & ", "
						EndIf
						If String($iMax) = "N" Then
							$iValTotalMax += 10000
							$sTexteTotalMax &= "n" & Chr($i + 64) & ", "
						ElseIf $iMax > 0 Then
							$iValTotalMax += $iMax
							$sTexteTotalMax &= $iMax & Chr($i + 64) & ", "
						EndIf
					Next
				EndIf
				If $bOk Then
					$sTexteTotalMin = StringTrimRight($sTexteTotalMin, 2)
					$sTexteTotalMin = StringReplace($sTexteTotalMin, ",", " et", -1)
					If $iValTotalMin > $iNbLettreRestant Then
						$bOk = False
						_Message("E", "Aucune solution ne pourra tre trouve puisque vous imposez " & $iValTotalMin & " lettres (" & $sTexteTotalMin & ") alors qu'il reste " & $iNbLettreRestant & " lettre" & _Pluriel($iNbLettreRestant) & "  trouver !", $FormLettrePLacee)
					EndIf
				EndIf
				If $bOk Then
					$sTexteTotalMax = StringTrimRight($sTexteTotalMax, 2)
					$sTexteTotalMax = StringReplace($sTexteTotalMax, ",", " et", -1)
					If $iValTotalMax < $iNbLettreRestant Then
						$bOk = False
						Switch $iValTotalMax
							Case 0
								_Message("E", "Aucune solution ne pourra tre trouve puisqu'aucune lettre n'est autorise !", $FormLettrePLacee)
							Case 1
								_Message("E", "Aucune solution ne pourra tre trouve puisque seulement le " & StringMid($sTexteTotalMax, 2, 1) & " est possible !", $FormLettrePLacee)
							Case Else
								If $iNbLettreRestant = 1 Then
									_Message("E", "Pour la lettre manquante, aucune solution ne pourra tre trouve puisque seulement " & $iValTotalMax & " lettres sont possibles : " & $sTexteTotalMax, $FormLettrePLacee)
								Else
									_Message("E", "Pour les " & $iNbLettreRestant & " lettres manquantes, aucune solution ne pourra tre trouve puisque seulement " & $iValTotalMax & " lettres sont possibles : " & $sTexteTotalMax, $FormLettrePLacee)
								EndIf
						EndSwitch
					EndIf
				EndIf
				If $bOk Then
					GUICtrlSetData($ButtonRechercherStopper, "STOPPER la recherche")
					$iNbLigne = LettrePlacee_Generer($FormLettrePLacee, $ListViewLettrePlacee, $iNbLettreTotal, $iNbLettreRestant, $InputLettre, $sLettrePlacee, $ButtonRechercherStopper)
					Switch $iNbLigne
						Case -1
							$sTexteColonne = "Arrt de"
						Case 0
							$sTexteColonne = "Aucun mot ne correspond "
						Case 1
							$sTexteColonne = "Un seul mot correspond "
						Case Else
							$sTexteColonne = _NumMillier($iNbLigne) & " mots correspondent "
					EndSwitch
					$sTexteColonne &= " votre recherche"
					_GUICtrlListView_SetColumn($ListViewLettrePlacee, 0, $sTexteColonne)
					GUICtrlSetData($ButtonRechercherStopper, "Valider cette recherche")
				EndIf
		EndSwitch
		If $bDoubleClicItem Then Definition($FormLettrePLacee, $ListViewLettrePlacee)
	WEnd
	GUIDelete($FormLettrePLacee)
	GUISetState(@SW_SHOW, $FormJe2Mots)
EndFunc


Func LettrePlacee_Generer($hForm, $ListView, $iNbLettreTotal, $iNbLettreRestant, $InputLettre, $sLettrePlacee, $ButtonStop)
	Local $s, $sSql, $saData, $hQuery, $iLettre, $i, $sMin, $sMax, $iNbLigne = 0
	GUISetCursor(15, 1, $hForm) ; Curseur WAIT
	_GUICtrlListView_DeleteAllItems($ListView)
	_GUICtrlListView_SetColumn($ListView, 0, "Recherche en cours ...")
	; Sql
	$sSql = "SELECT DicoMot FROM Dico Where"
	If $iNbLettreRestant = $iNbLettreTotal Then
		$sSql &= " Length(DicoMot) = " & $iNbLettreTotal
	Else
		$sSql &= " DicoMot Like '"
		For $i = 1 To $iNbLettreTotal
			If $sLettrePlacee[$i][0] = "" Then
				$sSql &= "_"
			Else
				$sSql &= $sLettrePlacee[$i][0]
			EndIf
		Next
		$sSql &= "'"
	EndIf
	For $iLettre = 1 To 26
		LettrePlacee_LettreMinMax(GUICtrlRead($InputLettre[$iLettre]), $sMin, $sMax)
		If Number($sLettrePlacee[$iLettre][1]) > 0 Then
			$sMin += Number($sLettrePlacee[$iLettre][1])
			If String($sMax) <> "N" Then $sMax += Number($sLettrePlacee[$iLettre][1])
		EndIf
		$s = ""
		Select
			Case (($sMin = 0) And (String($sMax) = "N"))
				; rien  faire
			Case (($sMin > 0) And (String($sMax) = "N"))
				$s = "DicoMot Like '%"
				For $i = 1 To $sMin
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
			Case (($sMin = 0) And ($sMax = 0))
				$s = "DicoMot Not Like '%" & Chr($iLettre +96) & "%'"
			Case (($sMin = 0) And ($sMax > 0))
				$s = "DicoMot Not Like '%"
				For $i = 1 To $sMax +1
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
			Case (($sMin > 0) And ($sMax > 0))
				$s = "DicoMot Like '%"
				For $i = 1 To $sMin
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "' And DicoMot Not Like '%"
				For $i = 1 To $sMax +1
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
		EndSelect
		If $s <> "" Then $sSql &= " And " & $s
	Next
	$sSql &= " ORDER BY DicoMot;"
	; Passer dans le tableau
	_SQlite_Query($hDbDico, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
		$iNbLigne += 1
		If (GUIGetMsg() = $ButtonStop) Or _IsPressed("1B", $hDllUser32) Then
			$iNbLigne = -1
			ExitLoop
		EndIf
		GUICtrlCreateListViewItem($saData[0], $ListView)
		_GUICtrlListView_EnsureVisible($ListView, $iNbLigne -1)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_SetItemSelected($ListView, 0)
	_GUICtrlListView_EnsureVisible($ListView, 0)
	ControlFocus($hForm, "", $ListView)
	GUISetCursor(2, 1, $hForm) ; Curseur Classique
	; Retourner le nombre de ligne
	Return $iNbLigne
EndFunc


Func LettrePlacee_AfficheLettrePlacee($InputLettreplacee, $LabelNbLettre, $iNbLettrePlacee, $Form)
	Local $i, $iPos = (715 - ($iNbLettrePlacee * 25) +80) / 2
	ControlMove($Form, "", $LabelNbLettre, $iPos - 80, 8)
	For $i = 1 To $iNbLettrePlacee
		ControlMove($Form, "", $InputLettreplacee[$i], $iPos, 8)
		GUICtrlSetState($InputLettreplacee[$i], $GUI_SHOW)
		$iPos += 25
	Next
	For $i = $iNbLettrePlacee +1 To 26
		GUICtrlSetData($InputLettreplacee[$i], "")
		GUICtrlSetState($InputLettreplacee[$i], $GUI_HIDE)
	Next
EndFunc


Func LettrePlacee_LettreMinMax($InputLettre, ByRef $iMin, ByRef $iMax)
	Local $i, $s, $bSecond = False
	$InputLettre = StringStripWS($InputLettre, 8)
	$iMin = ""
	$iMax = ""
	For $i = 1 To StringLen($InputLettre)
		$s = StringMid($InputLettre, $i, 1)
		Switch $s
			Case "-"
				If ($iMin = "") Or ($iMax <> "") Then Return ""
				$bSecond = True
			Case "0" To "9"
				If $bSecond Then
					If StringInStr($iMax, "N") > 0 Then Return ""
					$iMax &= $s
				Else
					If StringInStr($iMin, "N") > 0 Then Return ""
					$iMin &= $s
				EndIf
			Case "N"
				If $bSecond Then
					If $iMax <> "" Then Return ""
					$iMax = "N"
				Else
					If $iMin <> "" Then Return ""
					$iMin = "N"
				EndIf
			Case Else
				Return ""
		EndSwitch
	Next
	If $iMin = "" Then $iMin = "0"
	If $iMin = "N" Then
		Return ""
	Else
		$iMin = Number($iMin)
		Switch $iMax
			Case "N"
			Case ""
				$iMax = $iMin
			Case Else
				$iMax = Number($iMax)
				If ($iMin <> "N") And ($iMax < $iMin) Then Return ""
		EndSwitch
	EndIf
	Return $iMin & "-" & $iMax
EndFunc


Func LettrePlacee_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, $bMajInput)
	Switch $iCouleurLettre[$iIndice]
		Case 1 ; Rouge
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0xFF0000)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "0-0")
		Case 2 ; Orange
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0xFFB000)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "0-N")
		Case 3 ; Vert
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0x00FF00)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "1-N")
		Case 4 ; Gris
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0x353535)
	EndSwitch
EndFunc
#EndRegion - Lettres places --------------------------------------------------


#Region - Mot mystre ---------------------------------------------------------
Func MotMystere()
	Local $sMsg, $i, $s, $iPos, $iIndice, $iMinLongMot, $iMaxLongMot,  $iMin, $iMax, $iNbLigne, $iVoirDetail = $GUI_HIDE
	Local $bOk, $sTexteTotalMin, $iValTotalMin, $sTexteTotalMax, $iValTotalMax
	Local $LabelLettre[27], $iCouleurLettre[27], $InputLettre[27], $LabelTous[4]
	Local $sTexteColonne = "Liste mots possibles"
	Local $FormMotMystere = GUICreate("Mot mystre", 715, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	GUICtrlCreateLabel("Nombre de caractres du mot mystre (de 2  25)", 132, 12, 300, 19)
	GUICtrlSetFont(-1, 10)
	Local $InputNbLettreMin = GUICtrlCreateInput("10", 430, 8, 30, 23, BitOR($ES_CENTER, $ES_NUMBER))
	GUICtrlSetFont(-1, 11, 800)
	GUICtrlSetLimit(-1, 2)
	Local $LabelDetailNB = GUICtrlCreateLabel("", 466, 12, 16, 19)
	GUICtrlSetFont(-1, 10)
	GUICtrlSetState(-1, $GUI_HIDE)
	Local $InputNbLettreMax = GUICtrlCreateInput("10", 480, 8, 30, 23, BitOR($ES_CENTER, $ES_NUMBER))
	GUICtrlSetFont(-1, 11, 800)
	GUICtrlSetLimit(-1, 2)
	GUICtrlSetState(-1, $GUI_HIDE)
	Local $ButtonDetail = GUICtrlCreateButton("+ de dtails", 640, 11, 68, 21)
	$LabelTous[1] = GUICtrlCreateLabel("Lettre carte", 611, 36, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0xFF0000)
	$LabelTous[2] = GUICtrlCreateLabel("Lettre factutative", 511, 36, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0xFFB000)
	$LabelTous[3] = GUICtrlCreateLabel("Lettre obligatoire", 411, 36, 96, 15, BitOR($SS_CENTER, $WS_BORDER))
	GUICtrlSetBkColor(-1, 0x00FF00)
	$iPos = 8
	For $i = 65 To 90
		$LabelLettre[$i -64] = GUICtrlCreateLabel(Chr($i), $iPos, 57, 24, 22, BitOR($SS_CENTER, $WS_BORDER))
		GUICtrlSetFont(-1, 12, 800, 0, "Verdana")
		$iCouleurLettre[$i -64] = 1
		MotMystere_CouleurMinMax($i -64, $iCouleurLettre, $LabelLettre, $InputLettre, True)
		$iPos += 27
	Next
	$iPos = 8
	For $i = 65 To 90
		$InputLettre[$i -64] = GUICtrlCreateInput("0-0", $iPos -1, 80, 26, 20, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER))
		GUICtrlSetFont(-1, 8, 400, 0, "Calibri")
		GUICtrlSetState(-1, $GUI_HIDE)
		$iCouleurLettre[$i -64] = 1
		$iPos += 27
	Next
	Local $ButtonRechercherStopper = GUICtrlCreateButton("Valider cette recherche", 542, 104, 170, 25)
	Local $ListViewMotMystere = GUICtrlCreateListView($sTexteColonne, 181, 104, 352, $iFormHeight -110, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	_GUICtrlListView_SetColumnWidth($ListViewMotMystere, 0, 329)
	Local $ButtonSave = GUICtrlCreateButton("Enregistrer dans un fichier", 542, $iFormHeight -89, 170, 25)
	Local $ButtonClipBoard = GUICtrlCreateButton("Enregistrer dans le presse-papier", 542, $iFormHeight -60, 170, 25)
	Local $ButtonFermer = GUICtrlCreateButton("Fermer", 542, $iFormHeight -31, 170, 25)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFermer
				ExitLoop
			Case $LabelLettre[1] To $LabelLettre[26]
				$iIndice = $sMsg - $LabelLettre[1] +1
				$iCouleurLettre[$iIndice] += 1
				If $iCouleurLettre[$iIndice] > 3 Then $iCouleurLettre[$iIndice] = 1
				MotMystere_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, True)
			Case $InputLettre[1] To $InputLettre[26]
				$iIndice = $sMsg - $InputLettre[1] +1
				$s = MotMystere_LettreMinMax(GUICtrlRead($InputLettre[$iIndice]), $iMin, $iMax)
				If $s = "" Then
					$iCouleurLettre[$iIndice] = 4
					MotMystere_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, False)
					GUICtrlSetState($sMsg, $GUI_FOCUS)
				Else
					GUICtrlSetData($sMsg, $s)
					If ($iMin = 0) And (String($iMax) = "0") Then
						$iCouleurLettre[$iIndice] = 1
					ElseIf String($iMin) = "0" Then
						$iCouleurLettre[$iIndice] = 2
					Else
						$iCouleurLettre[$iIndice] = 3
					EndIf
					MotMystere_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, False)
				EndIf
			Case $LabelTous[1] To $LabelTous[3]
				$iPos = $sMsg - $LabelTous[1] +1
				For $i = 1 To 26
					$iCouleurLettre[$i] = $iPos
					MotMystere_CouleurMinMax($i, $iCouleurLettre, $LabelLettre, $InputLettre, True)
				Next
			Case $ButtonSave
				$s = Number(GUICtrlRead($InputNbLettreMin))
				If $iVoirDetail = $GUI_SHOW Then $s &= "a" & Number(GUICtrlRead($InputNbLettreMax))
				_ListViewSaveTxt($sTexteColonne, "MotMystere_" & $s & "_Lettres.txt", $ListViewMotMystere, $FormMotMystere)
			Case $ButtonClipBoard
				_ListViewClipPut($sTexteColonne, $ListViewMotMystere, $FormMotMystere)
			Case $ButtonDetail
				If $iVoirDetail = $GUI_HIDE Then
					$iVoirDetail = $GUI_SHOW
					GUICtrlSetData($ButtonDetail, "- de dtails")
				Else
					$iVoirDetail = $GUI_HIDE
					GUICtrlSetData($ButtonDetail, "+ de dtails")
					For $i = 1 To 26
						Switch $iCouleurLettre[$i]
							Case 1 ; Rouge
								GUICtrlSetData($InputLettre[$i], "0-0")
							Case 2 ; Orange
								GUICtrlSetData($InputLettre[$i], "0-N")
							Case 3 ; Vert
								GUICtrlSetData($InputLettre[$i], "1-N")
						EndSwitch
					Next
				EndIf
				For $i = 1 To 26
					GUICtrlSetState($InputLettre[$i], $iVoirDetail)
				Next
				GUICtrlSetState($InputNbLettreMax, $iVoirDetail)
				GUICtrlSetState($LabelDetailNB, $iVoirDetail)
				GUICtrlSetData($InputNbLettreMax, GUICtrlRead($InputNbLettreMin))
			Case $ButtonRechercherStopper
				$bOk = True
				$iMinLongMot = Number(GUICtrlRead($InputNbLettreMin))
				$iMaxLongMot = Number(GUICtrlRead($InputNbLettreMax))
				If $iVoirDetail = $GUI_HIDE Then
					$iMaxLongMot = $iMinLongMot
					GUICtrlSetData($InputNbLettreMax, $iMinLongMot)
				EndIf
				If $iMinLongMot > $iMaxLongMot Then
					$bOk = False
					_Message("E", "Le nombre de caractres minimum du mot mystre ne peut tre suprieur au nombre maximum", $FormMotMystere)
					GUICtrlSetState($InputNbLettreMin, $GUI_FOCUS)
				EndIf
				If $bOK And (($iMinLongMot > 25) Or ($iMinLongMot < 2)) Then
					$bOk = False
					_Message("E", "Le nombre de caractres minimum du mot mystre doit tre compris entre 2 et 25", $FormMotMystere)
					GUICtrlSetState($InputNbLettreMin, $GUI_FOCUS)
				EndIf
				If $bOK And (($iMaxLongMot > 25) Or ($iMaxLongMot < 2)) Then
					$bOk = False
					_Message("E", "Le nombre de caractres maximum du mot mystre doit tre compris entre 2 et 25", $FormMotMystere)
					GUICtrlSetState($InputNbLettreMax, $GUI_FOCUS)
				EndIf
				If $bOK Then
					$sTexteTotalMin = ""
					$iValTotalMin = 0
					$sTexteTotalMax = ""
					$iValTotalMax = 0
					For $i = 1 To 26
						If MotMystere_LettreMinMax(GUICtrlRead($InputLettre[$i]), $iMin, $iMax) = "" Then
							_Message("E", "La lettre " & Chr($i +64) & " est mal dfinie", $FormMotMystere)
							GUICtrlSetState($InputLettre[$i], $GUI_FOCUS)
							$bOk = False
							ExitLoop
						EndIf
						If $iMin > 0 Then
							$iValTotalMin += $iMin
							$sTexteTotalMin &= $iMin & Chr($i + 64) & ", "
						EndIf
						If String($iMax) = "N" Then
							$iValTotalMax += 10000
							$sTexteTotalMax &= "n" & Chr($i + 64) & ", "
						ElseIf $iMax > 0 Then
							$iValTotalMax += $iMax
							$sTexteTotalMax &= $iMax & Chr($i + 64) & ", "
						EndIf
					Next
				EndIf
				If $bOk Then
					$sTexteTotalMin = StringTrimRight($sTexteTotalMin, 2)
					$sTexteTotalMin = StringReplace($sTexteTotalMin, ",", " et", -1)
					If $iValTotalMin > $iMaxLongMot Then
						$bOk = False
						_Message("E", "Aucune solution ne pourra tre trouve puisque vous imposez " & $iValTotalMin & " lettres (" & $sTexteTotalMin & ") pour chercher un mot de " & $iMaxLongMot & " lettres !", $FormMotMystere)
					EndIf
				EndIf
				If $bOk Then
					$sTexteTotalMax = StringTrimRight($sTexteTotalMax, 2)
					$sTexteTotalMax = StringReplace($sTexteTotalMax, ",", " et", -1)
					If $iValTotalMax < $iMinLongMot Then
						$bOk = False
						Switch $iValTotalMax
							Case 0
								_Message("E", "Aucune solution ne pourra tre trouve puisqu'aucune lettre n'est autorise !", $FormMotMystere)
							Case 1
								_Message("E", "Aucune solution ne pourra tre trouve puisque seulement le " & StringMid($sTexteTotalMax, 2, 1) & " est possible !", $FormMotMystere)
							Case Else
								_Message("E", "Pour votre mot de " & $iMinLongMot & " lettres, aucune solution ne pourra tre trouve puisque seulement " & $iValTotalMax & " lettres sont possibles : " & $sTexteTotalMax, $FormMotMystere)
						EndSwitch
					EndIf
				EndIf
				If $bOk Then
					GUICtrlSetData($ButtonRechercherStopper, "STOPPER la recherche")
					$iNbLigne = MotMystere_Generer($FormMotMystere, $ListViewMotMystere, $iMinLongMot, $iMaxLongMot, $InputLettre, $ButtonRechercherStopper)
					Switch $iNbLigne
						Case -1
							$sTexteColonne = "Arrt de"
						Case 0
							$sTexteColonne = "Aucun mot ne correspond "
						Case 1
							$sTexteColonne = "Un seul mot correspond "
						Case Else
							$sTexteColonne = _NumMillier($iNbLigne) & " mots correspondent "
					EndSwitch
					$sTexteColonne &= " votre recherche"
					_GUICtrlListView_SetColumn($ListViewMotMystere, 0, $sTexteColonne)
					GUICtrlSetData($ButtonRechercherStopper, "Valider cette recherche")
				EndIf
		EndSwitch
		If $bDoubleClicItem Then Definition($FormMotMystere, $ListViewMotMystere)
		Sleep(30)
	WEnd
	GUIDelete($FormMotMystere)
	GUISetState(@SW_SHOW, $FormJe2Mots)
EndFunc


Func MotMystere_Generer($hForm, $ListView, $iMinLongMot, $iMaxLongMot, $InputLettre, $ButtonStop)
	Local $s, $sSql, $iLongInit, $saData, $hQuery, $iLettre, $sMin, $sMax, $iNbLigne = 0
	GUISetCursor(15, 1, $hForm) ; Curseur WAIT
	_GUICtrlListView_DeleteAllItems($ListView)
	_GUICtrlListView_SetColumn($ListView, 0, "Recherche en cours ...")
	; Sql
	$sSql = "SELECT DicoMot FROM Dico Where"
	$iLongInit = StringLen($sSql)
	For $iLettre = 1 To 26
		MotMystere_LettreMinMax(GUICtrlRead($InputLettre[$iLettre]), $sMin, $sMax)
		$s = ""
		Select
			Case (($sMin = 0) And (String($sMax) = "N"))
				; rien  faire
			Case (($sMin > 0) And (String($sMax) = "N"))
				$s = "DicoMot Like '%"
				For $i = 1 To $sMin
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
			Case (($sMin = 0) And ($sMax = 0))
				$s = "DicoMot Not Like '%" & Chr($iLettre +96) & "%'"
			Case (($sMin = 0) And ($sMax > 0))
				$s = "DicoMot Not Like '%"
				For $i = 1 To $sMax +1
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
			Case (($sMin > 0) And ($sMax > 0))
				$s = "DicoMot Like '%"
				For $i = 1 To $sMin
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "' And DicoMot Not Like '%"
				For $i = 1 To $sMax +1
					$s &= Chr($iLettre +96) & "%"
				Next
				$s &= "'"
		EndSelect
		If $s <> "" Then
			If $iLongInit <> StringLen($sSql) Then $sSql &= " And"
			$sSql &= " " & $s
		EndIf
	Next
	If $iLongInit <> StringLen($sSql) Then $sSql &= " And"
	If $iMinLongMot < $iMaxLongMot Then
		$sSql &= " Length(DicoMot) >= " & $iMinLongMot & " And Length(DicoMot) <= " & $iMaxLongMot & " ORDER BY DicoMot;"
	Else
		$sSql &= " Length(DicoMot) = " & $iMinLongMot & " ORDER BY DicoMot;"
	EndIf
	; Passer dans le tableau
	_SQlite_Query($hDbDico, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
		$iNbLigne += 1
		If (GUIGetMsg() = $ButtonStop) Or _IsPressed("1B", $hDllUser32) Then
			$iNbLigne = -1
			ExitLoop
		EndIf
		GUICtrlCreateListViewItem($saData[0], $ListView)
		_GUICtrlListView_EnsureVisible($ListView, $iNbLigne -1)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_SetItemSelected($ListView, 0)
	_GUICtrlListView_EnsureVisible($ListView, 0)
	ControlFocus($hForm, "", $ListView)
	GUISetCursor(2, 1, $hForm) ; Curseur Classique
	; Retourner le nombre de ligne
	Return $iNbLigne
EndFunc


Func MotMystere_LettreMinMax($InputLettre, ByRef $iMin, ByRef $iMax)
	Local $i, $s, $bSecond = False
	$InputLettre = StringStripWS($InputLettre, 8)
	$iMin = ""
	$iMax = ""
	For $i = 1 To StringLen($InputLettre)
		$s = StringMid($InputLettre, $i, 1)
		Switch $s
			Case "-"
				If ($iMin = "") Or ($iMax <> "") Then Return ""
				$bSecond = True
			Case "0" To "9"
				If $bSecond Then
					If StringInStr($iMax, "N") > 0 Then Return ""
					$iMax &= $s
				Else
					If StringInStr($iMin, "N") > 0 Then Return ""
					$iMin &= $s
				EndIf
			Case "N"
				If $bSecond Then
					If $iMax <> "" Then Return ""
					$iMax = "N"
				Else
					If $iMin <> "" Then Return ""
					$iMin = "N"
				EndIf
			Case Else
				Return ""
		EndSwitch
	Next
	If $iMin = "" Then $iMin = "0"
	If $iMin = "N" Then
		Return ""
	Else
		$iMin = Number($iMin)
		Switch $iMax
			Case "N"
			Case ""
				$iMax = $iMin
			Case Else
				$iMax = Number($iMax)
				If ($iMin <> "N") And ($iMax < $iMin) Then Return ""
		EndSwitch
	EndIf
	Return $iMin & "-" & $iMax
EndFunc


Func MotMystere_CouleurMinMax($iIndice, $iCouleurLettre, $LabelLettre, $InputLettre, $bMajInput)
	Switch $iCouleurLettre[$iIndice]
		Case 1 ; Rouge
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0xFF0000)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "0-0")
		Case 2 ; Orange
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0xFFB000)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "0-N")
		Case 3 ; Vert
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0x00FF00)
			If $bMajInput Then GUICtrlSetData($InputLettre[$iIndice], "1-N")
		Case 4 ; Gris
			GUICtrlSetBkColor($LabelLettre[$iIndice], 0x353535)
	EndSwitch
EndFunc
#EndRegion - Mot mystre ------------------------------------------------------


#Region - Anagramme simple ----------------------------------------------------
Func AnagrammeSimple()
	Local $i, $s, $sMotInitial
	While 1
		$sMotInitial = InputBox("Anagramme simple - Choix du mot", "Mot  'anagrammer'", $sMotInitial, "", 300, 130, (@DesktopWidth -300)/2, (@DesktopHeight - 130)/2, 360, $FormJe2Mots)
		$sMotInitial = StringStripWS($sMotInitial, 7)
		If $sMotInitial = "" Then Return
		$s = StringLower($sMotInitial)
		For $i = 1 To StringLen($sMotInitial)
			If Not StringInStr($scLettreOK, StringMid($s, $i, 1)) Then
				_Message("E", 'Vous ne pouvez pas utiliser le caractre "' & StringMid($s, $i, 1) & '"', $FormJe2Mots)
				$s = ""
				ExitLoop
			EndIf
		Next
		If $s = "" Then ExitLoop
		If AnagrammeSimple_VoirListeAnagramme($sMotInitial) Then ExitLoop
	WEnd
EndFunc


Func AnagrammeSimple_VoirListeAnagramme($sMotInitial)
	Local $sMsg, $iNbSolution, $sTexteColonne, $bFin = True
	Local $FormListeAnagramme = GUICreate("Anagrammes simples", 370, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	Local $ListViewAnagramme = GUICtrlCreateListView("Liste des anagrammes", 8, 8, 352, $iFormHeight -80, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	_GUICtrlListView_SetColumnWidth($ListViewAnagramme, 0, 329)
	;
	$iNbSolution = AnagrammeSimple_Generer($sMotInitial, $FormListeAnagramme, $ListViewAnagramme)
	Switch $iNbSolution
		Case 0
			$sTexteColonne = "Aucun anagramme ne correspond  : " & $sMotInitial
			_Message("I",$sTexteColonne , $FormListeAnagramme)
			Return False
		Case 1
			$sTexteColonne = "Le seul anagramme de : " & $sMotInitial
		Case Else
			$sTexteColonne = "Liste des " & $iNbSolution & " anagrammes de : " & $sMotInitial
	EndSwitch
	_GUICtrlListView_SetColumn($ListViewAnagramme, 0, $sTexteColonne)
	Local $ButtonSave = GUICtrlCreateButton("Enregistrer dans un fichier", 8, $iFormHeight -63, 170, 25)
	Local $ButtonClipBoard = GUICtrlCreateButton("Enregistrer dans le presse-papier", 190, $iFormHeight -63, 170, 25)
	Local $ButtonRetour = GUICtrlCreateButton("Autre mot", 8, $iFormHeight -31, 170, 25)
	Local $ButtonFin = GUICtrlCreateButton("Fin", 190, $iFormHeight -31, 170, 25)
	GUISetState(@SW_SHOW)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	;
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFin
				ExitLoop
			Case $ButtonRetour
				$bFin = False
				ExitLoop
			Case $ButtonSave
				_ListViewSaveTxt($sTexteColonne, "Anagramme_" & StringReplace($sMotInitial, " ", "_") & ".txt", $ListViewAnagramme, $FormListeAnagramme)
			Case $ButtonClipBoard
				_ListViewClipPut($sTexteColonne, $ListViewAnagramme, $FormListeAnagramme)
		EndSwitch
		If $bDoubleClicItem Then Definition($FormListeAnagramme, $ListViewAnagramme)
		Sleep(30)
	WEnd
	GUISetState(@SW_SHOW, $FormJe2Mots)
	GUIDelete($FormListeAnagramme)
	Return $bFin
EndFunc


Func AnagrammeSimple_Generer($sMot, $hForm, $ListView)
	Local $sSql, $iLongInit, $saData, $hQuery, $i, $iNb, $iNbLigne = 0
	GUISetCursor(15, 1, $hForm) ; Curseur WAIT
	; Sql
	$sSql = "SELECT DicoMot FROM Dico Where"
	$iLongInit = StringLen($sSql)
	For $i = 97 To 122 ; a to z
		StringReplace($sMot, Chr($i), "")
		$iNb = @extended
		If $iNb > 0 Then
			If $iLongInit <> StringLen($sSql) Then $sSql &= " And"
			$sSql &= " DicoMot Like '%"
			For $j = 1 To $iNb
				$sSql &= Chr($i) & "%"
			Next
			$sSql &= "' And DicoMot Not Like '%"
			For $j = 0 To $iNb
				$sSql &= Chr($i) & "%"
			Next
			$sSql &= "'"
		EndIf
	Next
	$sSql &= " And DicoMot <> '" & StringReplace(StringLower($sMot), "'", "''") & "' And Length(DicoMot) = " & StringLen($sMot) & " ORDER BY DicoMot;"
	; Passer dans le tableau
	_SQlite_Query($hDbDico, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
		$iNbLigne += 1
		GUICtrlCreateListViewItem($saData[0], $ListView)
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_SetItemSelected($ListView, 0)
	_GUICtrlListView_EnsureVisible($ListView, 0)
	ControlFocus($hForm, "", $ListView)
	GUISetCursor(2, 1, $hForm) ; Curseur Classique
	; Retourner le nombre de ligne
	Return $iNbLigne
EndFunc
#EndRegion - Anagramme simple -------------------------------------------------


#Region - Grer le dico -------------------------------------------------------
Func GererDico()
	Local $sMsg, $i, $s, $hQuery, $saData, $aRetour, $sSql, $iNbTrouve, $iNbNonTrouve
	Local Const $sFichierNonDef = @ScriptDir & "\Je2Mots-SansDefinition.txt"
	Local $FormGererDico = GUICreate("Grer votre dictionnaire", 386, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	GUICtrlCreateTab(8, 8, 370, $iFormHeight - 42)
	GUICtrlCreateTabItem("                Gestion des mots               ") ; ---------------------------------------
	Local $ListViewDico = GUICtrlCreateListView("Aucun mot", 16, 32, 352, $iFormHeight -166, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	_GUICtrlListView_SetColumnWidth($ListViewDico, 0, 329)
	Local $ComboLettre = GUICtrlCreateCombo("", 16, $iFormHeight -129, 172, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
	Local $ComboNBLettre = GUICtrlCreateCombo("", 196, $iFormHeight -129, 172, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
	Local $ButtonSupprimer = GUICtrlCreateButton("Supprimer les mots slectionns", 16, $iFormHeight -99, 172, 25)
	Local $ButtonAjouter = GUICtrlCreateButton("Ajouter un mot au dictionnaire", 196, $iFormHeight -99, 172, 25)
	Local $ButtonImporter = GUICtrlCreateButton("Importer depuis un fichier texte", 16, $iFormHeight -65, 172, 25)
	Local $ProgressBar = GUICtrlCreateProgress(16, $iFormHeight -110, 352, 20, $PBS_SMOOTH)
	GUICtrlSetState($ProgressBar, $GUI_HIDE)
	Local $ButtonStop = GUICtrlCreateButton("Stopper", 16, $iFormHeight -80, 352, 25)
	GUICtrlSetState($ButtonStop, $GUI_HIDE)
	GUICtrlCreateTabItem("          Gestion des dfinitions          ") ;----------------------------------------------
	GUICtrlCreateLabel("Cette cran vous permet d'enregistrer les dfinitions sur votre PC dans votre base de donnes au lieu d'aller charger systmatiquement la dfinition sur internet.", 16, 40, 352, 45)
	GUICtrlSetColor(-1, 0x3399FF)
	Local $LabelAvecDef = GUICtrlCreateLabel("", 16, 85, 350, 17)
	GUICtrlSetColor(-1, 0x919393)
	Local $LabelSansDef = GUICtrlCreateLabel("", 16, 105, 350, 17)
	GUICtrlSetColor(-1, 0x919393)
	GUICtrlCreateLabel("Rechercher  partir du mot", 16, 130, 134, 17)
	Local $InputMotMin = GUICtrlCreateInput("", 150, 127, 190, 21)
	GUICtrlCreateLabel("Et jusqu'au mot", 16, 155, 134, 17)
	Local $InputMotMax = GUICtrlCreateInput("", 150, 152, 190, 21)
	GUICtrlCreateLabel("Les mots qui ont dj une dfinition seront exclus", 16, 180, 334, 17)
	GUICtrlSetColor(-1, 0x919393)
	Local $ButtonAlimenter = GUICtrlCreateButton("Lancer l'enregistrement", 107, 210, 172, 25)
	Local $ButtonVoiListe = GUICtrlCreateButton("Liste des dfinitions non trouves", 107, 244, 172, 25)
	Local $LabelCompteur = GUICtrlCreateLabel("", 16, 212, 352, 17, $SS_CENTER)
	Local $LabelMotEnCours = GUICtrlCreateLabel("", 16, 242, 352, 34, $SS_CENTER)
	GUICtrlSetFont(-1, 9, 800)
	GUICtrlSetState(-1, $GUI_HIDE)
	Local $LabelStop = GUICtrlCreateLabel("Appuyer sur Echap (ESC) pour stopper le traitement", 16, 292, 352, 17, $SS_CENTER)
	GUICtrlSetFont(-1, 9, 800)
	GUICtrlSetColor(-1, 0xF91616)
	GUICtrlSetState(-1, $GUI_HIDE)
	GUICtrlCreateTabItem("")
	Local $ButtonFermer = GUICtrlCreateButton("Fermer", 290, $iFormHeight -31, 86, 25)
	; --------------------------------------------------------------------------------
	$s = "{Aucun}"
	For $i = 65 To 90
		$s &= "|" & Chr($i) & " comme premire lettre"
	Next
	GUICtrlSetData($ComboLettre, $s & "|[Tous]")
	_GUICtrlComboBox_SetCurSel($ComboLettre, 0)
	$s = "[Tous]|Mots de 1 lettre"
	For $i = 2 To 25
		$s &= "|Mots de " & $i & " lettres"
	Next
	GUICtrlSetData($ComboNBLettre, $s & " et +")
	_GUICtrlComboBox_SetCurSel($ComboNBLettre, 0)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	GUISetState(@SW_SHOW, $FormGererDico)
	GUISetCursor(15, 1, $FormGererDico) ; Curseur WAIT
	GererDico_Afficher($FormGererDico, $ListViewDico, "", _GUICtrlComboBox_GetCurSel($ComboLettre), _GUICtrlComboBox_GetCurSel($ComboNBLettre), $ButtonStop, $ProgressBar)
	$i = _DicoNbMotsSansDefinition()
	GUICtrlSetData($LabelAvecDef, "Nombre de mots ayant une dfinition avec le traitement          : " & _NumMillier(_DicoNbTousMots(False) - $i))
	GUICtrlSetData($LabelSansDef, "Nombre de mots n'ayant pas une dfinition avec le traitement : " & _NumMillier($i))
	GUISetCursor(2) ; Curseur Classique
	;
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFermer
				ExitLoop
			Case $ComboLettre, $ComboNBLettre
				GererDico_AfficherMasquer(False, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
				GererDico_Afficher($FormGererDico, $ListViewDico, "", _GUICtrlComboBox_GetCurSel($ComboLettre), _GUICtrlComboBox_GetCurSel($ComboNBLettre), $ButtonStop, $ProgressBar)
				GererDico_AfficherMasquer(True, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
			Case $ButtonSupprimer
				If GererDico_SuppressionListeMot($ListViewDico, $FormGererDico) Then
					GererDico_AfficherMasquer(False, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
					GererDico_Afficher($FormGererDico, $ListViewDico, "", _GUICtrlComboBox_GetCurSel($ComboLettre), _GUICtrlComboBox_GetCurSel($ComboNBLettre), $ButtonStop, $ProgressBar)
					GererDico_AfficherMasquer(True, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
				EndIf
			Case $ButtonAjouter
				$s = GererDico_AjouterMot($ListViewDico, $FormGererDico)
				If $s <> "" Then
					GererDico_AfficherMasquer(False, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
					GererDico_Afficher($FormGererDico, $ListViewDico, $s, _GUICtrlComboBox_GetCurSel($ComboLettre), _GUICtrlComboBox_GetCurSel($ComboNBLettre), $ButtonStop, $ProgressBar)
					GererDico_AfficherMasquer(True, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
				EndIf
			Case $ButtonImporter
				GererDico_AfficherMasquer(False, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
				If GererDico_Importer($ListViewDico, $FormGererDico, $ButtonStop, $ProgressBar) Then _
					GererDico_Afficher($FormGererDico, $ListViewDico, "", _GUICtrlComboBox_GetCurSel($ComboLettre), _GUICtrlComboBox_GetCurSel($ComboNBLettre), $ButtonStop, $ProgressBar)
				GererDico_AfficherMasquer(True, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
			Case $ButtonAlimenter
				GUICtrlSetState($ButtonAlimenter, $GUI_HIDE)
				GUICtrlSetState($ButtonVoiListe, $GUI_HIDE)
				GUICtrlSetData($LabelMotEnCours, "")
				GUICtrlSetState($LabelMotEnCours, $GUI_SHOW)
				GUICtrlSetData($LabelCompteur, "")
				GUICtrlSetState($LabelCompteur, $GUI_SHOW)
				GUICtrlSetState($LabelStop, $GUI_SHOW)
				FileWriteLine($sFichierNonDef, "Dbut de la liste des mots non trouvs : " & @MDAY & "-" & @MON & "-" & @YEAR & " " & @HOUR & ":" & @MIN)
				$iNbTrouve = 0
				$iNbNonTrouve = 0
				$sSql = "LienIdDico Is Null"
				$s = StringLower(StringStripWS(GUICtrlRead($InputMotMin), 7))
				If $s <> "" Then $sSql &= " AND DicoMot >= " &  _SQLite_Escape($s)
				$s = StringLower(StringStripWS(GUICtrlRead($InputMotMax), 7))
				If $s <> "" Then $sSql &= " AND DicoMot <= " &  _SQLite_Escape($s)
				$sSql = "SELECT DicoMot FROM Dico LEFT JOIN Lien ON Dico.ROWID = LienIdDIco WHERE " & $sSql & " ORDER BY DicoMot;"
				_SQLite_Exec($hDbDico, "BEGIN;")
				_SQlite_Query($hDbDico, $sSql, $hQuery)
				While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
					$aRetour = _DicoDefinition($sStrategieDeRecherche, $saData[0], $FormGererDico)
					If $aRetour[0][0] = -2 Then ExitLoop
					GUICtrlSetData($LabelMotEnCours, _DixNombresLettre($aRetour[0][0]) & " dfinition" & _Pluriel($aRetour[0][0]) & " du mot " & $saData[0] & " sur " & $aRetour[0][1])
					If $aRetour[0][0] <= 0 Then
						$iNbNonTrouve += 1
						FileWriteLine($sFichierNonDef, $saData[0])
					Else
						$iNbTrouve += 1
					EndIf
					GUICtrlSetData($LabelCompteur, "Nombre de dfinitions : OK=" & _NumMillier($iNbTrouve) & ", KO=" & _NumMillier($iNbNonTrouve))
					For $i = 1 To $aRetour[0][0]
						_DbEnregistrerDefinition($saData[0], $aRetour[0][2], $aRetour[$i][0], $aRetour[$i][1], $aRetour[$i][2])
					Next
					If Mod($iNbTrouve, 500) = 0 Then ; Faire un COMMIT tous les 500 enregistrements
						_SQLite_Exec($hDbDico, "COMMIT;")
						Sleep(500)
						_SQLite_Exec($hDbDico, "BEGIN;")
					EndIf
				WEnd
				GUICtrlSetState($LabelStop, $GUI_HIDE)
				GUICtrlSetState($LabelMotEnCours, $GUI_HIDE)
				_SQLite_QueryFinalize($hQuery)
				_SQLite_Exec($hDbDico, "COMMIT;")
				FileWriteLine($sFichierNonDef, "Fin de la liste des mots non trouvs : " & @MDAY & "-" & @MON & "-" & @YEAR & " " & @HOUR & ":" & @MIN)
				GUICtrlSetState($LabelCompteur, $GUI_HIDE)
				GUICtrlSetState($ButtonAlimenter, $GUI_SHOW)
				GUICtrlSetState($ButtonVoiListe, $GUI_SHOW)
				_Message("I", "Rsultat de l'alimentation des difinitions" & @CRLF & "Nombre de dfinitions trouves : " & $iNbTrouve & @CRLF & "Nombre de dfinitions non trouves : " & $iNbNonTrouve, $FormGererDico)
			Case $ButtonVoiListe
				If Not FileExists($sFichierNonDef) Then
					_Message("E", "Liste non disponible (" & $sFichierNonDef & ")", $FormGererDico)
				Else
					GUISetCursor(15, 1, $FormGererDico) ; Curseur WAIT
					ShellExecute($sFichierNonDef)
					GUISetCursor(2) ; Curseur Classique
				EndIf
		EndSwitch
		If $bDoubleClicItem Then Definition($FormGererDico, $ListViewDico)
		Sleep(10)
	WEnd
	GUIDelete($FormGererDico)
	GUISetState(@SW_SHOW, $FormJe2Mots)
EndFunc


Func GererDico_Importer($ListViewDico, $hForm, $ButtonStop, $ProgressBar)
	Local $i, $s, $sFichierImport, $hTxtImport, $sMot, $saData, $sListeOk, $iNbWait, $iNbBoucle, $iNbStep
	Local $iNbMotNouveau = 0, $iNbMotIdem = 0, $iNbMotKO = 0, $iNbLigneBlanche = 0, $iNbSql, $iNbLigne
	Local Const $scMin = "[abcdefghijklmnopqrstuvwxyz]"
	Local Const $scMaj = StringUpper($scMin)
	Local Const $scAccent = "[]"
	Local Const $scSansAccent = "[aaaaaaceeeeiiiinooooouuuuyy]"
	$sFichierImport = FileOpenDialog("Nom du fichier de mots  prendre en compte", "", "Txt (*.txt)|Tous les fichiers (*.*)", 1, "", $hForm)
	If (@error <> 0) or ($sFichierImport = "") Then Return False
	$iNbLigne = GererDico_NbLignesFichierTexte($sFichierImport)
	$iNbStep = _Min($iNbLigne / 100, 1000)
	$hTxtImport = FileOpen($sFichierImport, 0)
	If @error = -1 Then
		_Message("E", "Le fichier " & $sFichierImport & " ne peut pas tre ouvert !", $hForm)
		Return False
	EndIf
	GUISetCursor(15, 1, $hForm) ; Curseur WAIT
	; Parcours du fichier Texte
	_SQLite_Exec($hDbDico, "BEGIN;")
	While 1
		$iNbWait += 1
		If $iNbWait = 100 Then
			$iNbWait = 0
			If (GUIGetMsg() = $ButtonStop) Or _IsPressed("1B", $hDllUser32) Then ExitLoop
		EndIf
		$iNbBoucle += 1
		If $iNbBoucle > $iNbStep Then
			GUICtrlSetData($ProgressBar, ($iNbLigneBlanche + $iNbMotKO + $iNbMotIdem + $iNbMotNouveau) / $iNbLigne * 100)
			$iNbBoucle = 0
		EndIf
		$sMot = FileReadLine($hTxtImport)
		If @error = -1 Then ExitLoop
		$sMot = StringStripWS($sMot, 7)
		If $sMot = "" Then
			$iNbLigneBlanche += 1
			ContinueLoop
		EndIf
		; Doubler les '
		$sMot = StringReplace($sMot, "'", "''")
		; Passer en minuscule
		If StringRegExp($sMot, $scMaj) Then
			For $i = 2 To StringLen($scMaj) -1
				$sMot = StringReplace($sMot, StringMid($scMaj, $i, 1), StringMid($scMin, $i, 1), 0, 1)
			Next
		EndIf
		; Oter les accents
		If StringRegExp($sMot, $scAccent) Then
			For $i = 2 To StringLen($scAccent) -1
				$sMot = StringReplace($sMot, StringMid($scAccent, $i, 1), StringMid($scSansAccent, $i, 1), 0, 1)
			Next
		EndIf
		; Mot OK ?
		For $i = 1 To StringLen($sMot)
			If Not StringInStr($scLettreOK, StringMid($sMot, $i, 1), 1) Then
				$iNbMotKO += 1
				ContinueLoop 2
			EndIf
		Next
		; Dj prsent dans le dico ?
		If _SQLite_QuerySingleRow($hDbDico, "SELECT DicoMot FROM Dico WHERE DicoMot = '" & $sMot & "';", $saData) = $SQLITE_OK Then
			$iNbMotIdem += 1
			ContinueLoop
		EndIf
		; Enregistrer
		If _SQLite_Exec($hDbDico, "INSERT INTO Dico (DicoMot) VALUES ('" & $sMot & "');") = $SQLITE_OK Then
			$sListeOk &= $sMot & @CRLF
			$iNbMotNouveau += 1
		Else
			$iNbMotKO += 1
		EndIf
	WEnd
	FileClose($hTxtImport)
	GUISetCursor(2, 1, $hForm) ; Curseur Classique
	$s = "Rsultat de l'importation du fichier " & $sFichierImport & @CRLF & @CRLF
	$s &= "- Nombre de nouveaux mots   : " & $iNbMotNouveau & @CRLF
	$s &= "- Nombre de mots identiques  : " & $iNbMotIdem & @CRLF
	$s &= "- Nombre de mots KO               : " & $iNbMotKO & @CRLF
	$s &= "- Nombre de lignes vides          : " & $iNbLigneBlanche & @CRLF & @CRLF
	If $iNbMotNouveau = 0 Then
		$s &= "Donc aucun nouveau mot insr dans votre dictionnaire !"
		_Message("I", $s, $hForm)
		Return False
	Else
		ClipPut($sListeOk)
		$s &= "(La liste des nouveaux mots est dans votre presse-papier)" & @CRLF & @CRLF
		$s &= "Confirmez-vous de l'ajout des " & $iNbMotNouveau & " mots dans votre dictionnaire ?"
		If _Message("C", $s, $hForm) = 6 Then
			_SQLite_Exec($hDbDico, "COMMIT;")
			If _SQLite_QuerySingleRow($hDbDico, $sGererDicoSqlCount, $saData) <> $SQLITE_OK Then
				$iNbSql = 0
			Else
				$iNbSql = $saData[0]
			EndIf
			GUISetCursor(15, 1, $hForm) ; Curseur WAIT
			_SQLite_Exec($hDbDico, "Vacuum")
			GUISetCursor(2, 1, $hForm) ; Curseur Classique
			If _GUICtrlListView_GetItemCount($ListViewDico) = $iNbSql Then
				_Message("I", "Les " & $iNbMotNouveau & " nouveaux mots ont t insrs dans votre dictionnaire", $hForm)
				Return False
			Else
				Return True
			EndIf
		Else
			_SQLite_Exec($hDbDico, "ROLLBACK;")
			Return False
		EndIf
	EndIf
	_NiToucheNiEsc()
EndFunc


Func GererDico_NbLignesFichierTexte($sFichier)
	Local $hTxt, $sText, $iNb, $siTaille
	If Not FileExists($sFichier) Then Return 0
	$siTaille = FileGetSize($sFichier)
	If $siTaille > (1024 * 1024 * 10) Then ; Plus de 10 Mga
		Return $siTaille / 11 ; 11 caractres en moyenne
	Else
		$hTxt = FileOpen($sFichier, 0)
		If @error = -1 Then Return 0
		$sText = FileRead($hTxt)
		StringReplace($sText, @LF, "")
		$iNb = @extended
		Return $iNb
	EndIf
EndFunc


Func GererDico_AjouterMot($ListViewDico, $hForm)
	Local $i, $sMot, $bOk, $saData, $iNbSql
	While 1
		$sMot = InputBox("Nouveau mot", "Mot  ajouter  votre dictionnaire" & @CRLF & "Vous devez utiliser les lettres de 'a'  'z'", $sMot, "", 340, 140, (@DesktopWidth -300)/2, (@DesktopHeight - 130)/2, 360, $hForm)
		If $sMot = "" Then Return ""
		$bOk = True
		For $i = 1 To StringLen($sMot)
			If Not StringInStr($scLettreOK, StringMid($sMot, $i, 1), 1) Then
				_Message("E", 'Vous ne pouvez pas utiliser le caractre "' & StringMid(StringMid($sMot, $i, 1), $i, 1) & '"', $hForm)
				$bOk = False
				ExitLoop
			EndIf
		Next
		If $bOk Then
			If _SQLite_QuerySingleRow($hDbDico, "SELECT * FROM Dico WHERE DicoMot = '" & StringReplace($sMot, "'", "''") & "';", $saData) = $SQLITE_OK Then
				_Message("E", "Ce mot existe dj dans votre dictionnaire", $hForm)
			Else
				If _SQLite_Exec($hDbDico, "INSERT INTO Dico (DicoMot) VALUES ('" & StringReplace($sMot, "'", "''") & "');") <> $SQLITE_OK Then
					_Message("E", "Ce mot n'a pas pu tre enregistr (je ne sais pas pourquoi !)", $hForm)
				Else
					If _SQLite_QuerySingleRow($hDbDico, $sGererDicoSqlCount, $saData) <> $SQLITE_OK Then
						$iNbSql = 0
					Else
						$iNbSql = $saData[0]
					EndIf
					If _GUICtrlListView_GetItemCount($ListViewDico) = $iNbSql Then
						_Message("I", $sMot & " a t ajout  votre dictionnaire", $hForm)
						$sMot = ""
					EndIf
					ExitLoop
				EndIf
			EndIf
		EndIf
	WEnd
	Return $sMot
EndFunc


Func GererDico_SuppressionListeMot($ListViewDico, $hForm)
	Local $s, $i, $iaIndices = _GUICtrlListView_GetSelectedIndices($ListViewDico, True)
	For $i = 1 To $iaIndices[0]
		If $i > 1 Then $s &= @CRLF
		$s &= _GUICtrlListView_GetItemText($ListViewDico, $iaIndices[$i])
	Next
	Switch $iaIndices[0]
		Case 0
			_Message("I", "Aucun mot slectionn !", $hForm)
			Return False
		Case 1
			If _Message("C", "Confirmez-vous la suppression du mot  : " & $s, $hForm) = 7 Then Return False
		Case 2 To 40
			If _Message("C", "Confirmez-vous la suppression des " & $iaIndices[0] & " mots :" & @CRLF & $s, $hForm) = 7 Then Return False
		Case Else
			If _Message("C", "Confirmez-vous la suppression des " & $iaIndices[0] & " mots :" & @CRLF & StringReplace($s, @CRLF, ", "), $hForm) = 7 Then Return False
	EndSwitch
	; Supprimer les mots
	For $i = 1 To $iaIndices[0]
		_DbSupprimerUnMot(_GUICtrlListView_GetItemText($ListViewDico, $iaIndices[$i]))
	Next
	Return True
EndFunc


Func GererDico_Afficher($hForm, $ListViewDico, $sMotSelectionne, $iIndiceLettre, $iIndiceNb, $ButtonStop, $ProgressBar)
	Local $s, $sSql, $hQuery, $saData, $iNbStep, $iNbBoucle, $iNbAffiche, $iNbData, $iNbWait, $iIndice
	_GUICtrlListView_SetColumn($ListViewDico, 0, "Liste en cours ...")
	_GUICtrlListView_DeleteAllItems(GUICtrlGetHandle($ListViewDico))
	If $iIndiceLettre = 0 Then
		_GUICtrlListView_SetColumn($ListViewDico, 0, "Mots du dictionnaire")
		Return
	EndIf
	$sGererDicoSqlCount = "SELECT COUNT(*) FROM Dico "
	If ($iIndiceLettre <> 27) Or ($iIndiceNb <> 0) Then
		$sGererDicoSqlCount &= "WHERE "
		If $iIndiceLettre <= 26 Then $sGererDicoSqlCount &= "DicoMot LIKE '" & Chr($iIndiceLettre +96) & "%' "
		If $iIndiceNb > 0 Then
			If $iIndiceLettre <= 26 Then $sGererDicoSqlCount &= "AND "
			If $iIndiceNb = 25 Then
				$sGererDicoSqlCount &= "Length(DicoMot) >= 25 "
			Else
				$sGererDicoSqlCount &= "Length(DicoMot) = " & $iIndiceNb & " "
			EndIf
		EndIf
	EndIf
	$sGererDicoSqlCount &= "ORDER BY DicoMot;"
	If _SQLite_QuerySingleRow($hDbDico, $sGererDicoSqlCount, $saData) <> $SQLITE_OK Then ReDim $saData[0]
	$iNbData = Number($saData[0])
	$iNbStep = _Min(Floor($iNbData / 100), 2000)
	$sSql = StringReplace($sGererDicoSqlCount, "COUNT(*)", "DicoMot", 1) ; Requte de slection (mme que Count())
	_GUICtrlListView_BeginUpdate($ListViewDico)
	_SQlite_Query($hDbDico, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
		$iNbAffiche += 1
		_GUICtrlListView_AddItem($ListViewDico, $saData[0]) ; GUICtrlCreateListViewItem() 35% plus rapide mais ne gre qu'un nombre limit de lignes
		$iNbWait += 1
		If $iNbWait = 100 Then
			$iNbWait = 0
			If (GUIGetMsg() = $ButtonStop) Or _IsPressed("1B", $hDllUser32) Then
				$iNbData = -1
				ExitLoop
			EndIf
		EndIf
		$iNbBoucle += 1
		If $iNbBoucle > $iNbStep Then
			GUICtrlSetData($ProgressBar, $iNbAffiche / $iNbData * 100)
			$iNbBoucle = 0
			_GUICtrlListView_EndUpdate($ListViewDico)
			_GUICtrlListView_EnsureVisible($ListViewDico, _GUICtrlListView_GetItemCount($ListViewDico) -1)
			_GUICtrlListView_BeginUpdate($ListViewDico)
		EndIf
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_EndUpdate($ListViewDico)
	If $sMotSelectionne = "" Then
		$iIndice = 0
	Else
		$iIndice = _GUICtrlListView_FindInText($ListViewDico, $sMotSelectionne)
		If $iIndice = -1 Then $iIndice = 0
	EndIf
	_GUICtrlListView_SetItemSelected($ListViewDico, $iIndice)
	_GUICtrlListView_EnsureVisible($ListViewDico, $iIndice)
	ControlFocus($hForm, "", $ListViewDico)
	Switch $iNbData
		Case -1
			_GUICtrlListView_SetColumn($ListViewDico, 0, "Arrt aprs " & _NumMillier(_GUICtrlListView_GetItemCount($ListViewDico)) & " mots")
			 _NiToucheNiEsc(30)
			 Return
		Case 0
			$s = "Aucun mot"
		Case 1
			$s = "Un seul mot"
		Case Else
			$s = _NumMillier($iNbData) & " mots"
	EndSwitch

	Switch $iIndiceNb
		Case 1
			$s &= " d'une lettre"
		Case 2 To 24
			$s &= " de " & $iIndiceNb & " lettres"
		Case 25
			$s &= " de 25 lettres et plus"
	EndSwitch
	If ($iIndiceLettre >= 1) And ($iIndiceLettre <= 26) Then $s &= " commenant par un " & Chr($iIndiceLettre +64)
	_GUICtrlListView_SetColumn($ListViewDico, 0, $s)
EndFunc


Func GererDico_AfficherMasquer($bAfficher, $ComboLettre, $ComboNBLettre, $ButtonAjouter, $ButtonSupprimer, $ButtonImporter, $ButtonStop, $ProgressBar, $ButtonFermer)
	Local $iMasquer = $GUI_HIDE, $iAfficher = $GUI_SHOW
	If $bAfficher Then
		$iMasquer = $GUI_SHOW
		$iAfficher = $GUI_HIDE
	EndIf
	GUICtrlSetState($ComboLettre, $iMasquer)
	GUICtrlSetState($ComboNBLettre, $iMasquer)
	GUICtrlSetState($ButtonAjouter, $iMasquer)
	GUICtrlSetState($ButtonSupprimer, $iMasquer)
	GUICtrlSetState($ButtonImporter, $iMasquer)
	GUICtrlSetState($ButtonFermer, $iMasquer)
	GUICtrlSetState($ButtonStop, $iAfficher)
	GUICtrlSetData($ProgressBar, 0)
	GUICtrlSetState($ProgressBar, $iAfficher)
EndFunc
#EndRegion - Grer le dico ----------------------------------------------------


#Region - Anagramme-Multi -----------------------------------------------------
Func AnagrammeMulti()
	Local Const $scCarOK = $scLettreOK & " "
	Local $i, $s, $sTexteInitial
	While 1
		$sTexteInitial = InputBox("Anagramme multi-mots - Choix du text", "Texte  'anagrammer'", $sTexteInitial, "", 300, 130, (@DesktopWidth -300)/2, (@DesktopHeight - 130)/2, 360, $FormJe2Mots)
		$sTexteInitial = StringStripWS($sTexteInitial, 7)
		If $sTexteInitial = "" Then	Return
		$s = StringLower($sTexteInitial)
		For $i = 1 To StringLen($sTexteInitial)
			If Not StringInStr($scCarOK, StringMid($s, $i, 1)) Then
				_Message("E", "Vous ne pouvez pas utiliser le caractre '" & StringMid($s, $i, 1) & "'", $FormJe2Mots)
				$s = ""
				ExitLoop
			EndIf
		Next
		If $s <> "" And AnagrammeMulti_GererListeMotsPossibles($sTexteInitial) Then ExitLoop
	WEnd
EndFunc


Func AnagrammeMulti_VoirListeAnagramme($saListeDico, $sTexteInitial)
	Local $sMsg, $saSolution, $sTexteColonne, $sFichier, $hFile, $bOK, $bFin = True
	Local $FormListeAnagramme = GUICreate("Liste des anagrammes de : " & $sTexteInitial, 370, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	Local $ListViewAnagramme = GUICtrlCreateListView("Liste des anagrammes", 8, 8, 352, $iFormHeight -80, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	Local $ProgressBar = GUICtrlCreateProgress(8, $iFormHeight -63, 352, 20, $PBS_SMOOTH)
	Local $ButtonStop = GUICtrlCreateButton("Stopper la recherche", 8, $iFormHeight -33, 352, 25)
	_GUICtrlListView_SetColumnWidth($ListViewAnagramme, 0, 329)
	GUISetState(@SW_SHOW)
	;
	$saSolution = AnagrammeMulti_Generer($saListeDico, $sTexteInitial, $FormListeAnagramme, $ListViewAnagramme, $ButtonStop, $ProgressBar)
	ControlFocus($FormListeAnagramme, "", $ListViewAnagramme)
	_GUICtrlListView_SetItemSelected($ListViewAnagramme, 0)
	_GUICtrlListView_EnsureVisible($ListViewAnagramme, 0)
	;
	$sTexteColonne = "Liste des " & $saSolution[0] & " anagrammes de : " & $sTexteInitial
	If $saSolution[0] > 0 Then _GUICtrlListView_SetColumn($ListViewAnagramme, 0, $sTexteColonne)
	GUICtrlSetState($ProgressBar, $GUI_HIDE)
	GUICtrlSetState($ButtonStop, $GUI_HIDE)
	_NiToucheNiEsc(30)
	If $saSolution[0] = 0 Then _Message("I", "Aucun anagramme ne correspond  : " & $sTexteInitial, $FormListeAnagramme)
	Local $ButtonSave = GUICtrlCreateButton("Enregistrer dans un fichier", 8, $iFormHeight -63, 170, 25)
	Local $ButtonClipBoard = GUICtrlCreateButton("Enregistrer dans le presse-papier", 190, $iFormHeight -63, 170, 25)
	Local $ButtonRetour = GUICtrlCreateButton("Retour  la liste des mots", 8, $iFormHeight -31, 170, 25)
	Local $ButtonFin = GUICtrlCreateButton("Fin", 190, $iFormHeight -31, 170, 25)
	;
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonFin
				If ($saSolution[0] <= 0) Or (_Message("C", "Voulez-vous terminer cet anagramme ?", $FormListeAnagramme) = 6) Then ExitLoop
			Case $ButtonRetour
				$bFin = False
				ExitLoop
			Case $ButtonSave
				$sFichier = FileSaveDialog("Nom du fichier", "", "Txt (*.txt)|Tous les fichiers (*.*)", 18, "Anagramme_" & StringReplace($sTexteInitial, " ", "_") & ".txt", $FormListeAnagramme)
				If (@error = 0) And ($sFichier <> "") Then
					$bOK = False
					$hFile = FileOpen($sFichier, 10)
					If $hFile <> -1 Then
						$bOK = FileWrite($hFile, _TableauEnUnTexte($sTexteColonne, $saSolution))
						FileClose($hFile)
					EndIf
					If $bOK Then
						_Message("I", "La liste a t copie dans le fichier " & $sFichier, $FormListeAnagramme)
					Else
						_Message("E", "ERREUR : La liste n'a pas t copie dans le fichier " & $sFichier, $FormListeAnagramme)
					EndIf
				EndIf
			Case $ButtonClipBoard
				If ClipPut(_TableauEnUnTexte($sTexteColonne, $saSolution)) Then
					_Message("I", "La liste a t copie dans votre presse-papier", $FormListeAnagramme)
				Else
					_Message("E", "ERREUR : La liste n'a pas t copie dans votre presse-papier !!!", $FormListeAnagramme)
				EndIf
		EndSwitch
		If $bDoubleClicItem Then Definition($FormListeAnagramme, $ListViewAnagramme)
		Sleep(30)
	WEnd
	GUIDelete($FormListeAnagramme)
	_NiToucheNiEsc(20)
	Return $bFin
EndFunc


Func AnagrammeMulti_GererListeMotsPossibles($sTexteInitial)
	Local $sMsg, $i, $iNb, $iaIndices, $saDico, $saListeAPasser, $asListeListView
	Local $FormListeMot = GUICreate("Liste des mots possibles pour l'anagramme de : " & $sTexteInitial, 488, $iFormHeight, -1, $iFormTop +8)
	GUISetBkColor(0xB8DDFD)
	Local $ListViewMot = _GUICtrlListView_Create($FormListeMot, "Liste des mots|x", 8, 8, 472, $iFormHeight -144, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS))
	_GUICtrlListView_SetExtendedListViewStyle($ListViewMot, BitOR($LVS_EX_CHECKBOXES, $LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
	Local $LabelWait = GUICtrlCreateLabel("Liste en cours de cration ...", 8, $iFormHeight -72, 472, 25, $SS_CENTER)
	_GUICtrlListView_SetColumnWidth($ListViewMot, 0, 285)
	_GUICtrlListView_SetColumn($ListViewMot, 1, "Supprimer pour l'anagramme", 170, 2)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	GUISetState(@SW_SHOW, $FormListeMot)
	;
	MouseMove(@DesktopWidth / 2, @DesktopHeight / 2)
	GUISetCursor(15, 1, $FormListeMot) ; Curseur WAIT
	$saDico = AnagrammeMulti_CreerListeMotsPossibles($sTexteInitial, $FormListeMot)
	If $saDico[0] > 0 Then
		_GUICtrlListView_SetColumn($ListViewMot, 0, "Liste des " & $saDico[0] & " mots")
		Dim $asListeListView[$saDico[0]][4]
		For $i = 0 To $saDico[0] -1
			$asListeListView[$i][0] = $saDico[$i +1]
			$asListeListView[$i][1] = 0
			$asListeListView[$i][2] = StringLen($saDico[$i +1])
		Next
		AnagrammeMulti_GererListeMotsPossiblesListview($ListViewMot, $asListeListView)
	Else
		GUISetCursor(2, 1, $FormListeMot) ; Curseur Classique
		GUIDelete($FormListeMot)
		GUISetState(@SW_SHOW, $FormJe2Mots)
		Return False
	EndIf
	;
	GUICtrlSetState($LabelWait, $GUI_HIDE)
	_NiToucheNiEsc(100)
	Local $ButtonSupListe = GUICtrlCreateButton("Supprimer les mots cochs pour cet anagramme", 8, $iFormHeight -127, 233, 25)
	Local $ButtonRemettre = GUICtrlCreateButton("Remettre les mots cochs dans la liste", 8, $iFormHeight -95, 233, 25)
	Local $ButtonSelCocher = GUICtrlCreateButton("Cocher les lignes slectionnes", 8, $iFormHeight -63, 233, 25)
	Local $ButtonSelDeCocher = GUICtrlCreateButton("Dcocher les lignes slectionnes", 8, $iFormHeight -31, 233, 25)
	Local $ComboTrier = GUICtrlCreateCombo("", 249, $iFormHeight -127, 233, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
	Local $ButtonAbandonner = GUICtrlCreateButton("Abandonner", 249, $iFormHeight -31, 113, 25)
	Local $ButtonValider = GUICtrlCreateButton("Valider", 369, $iFormHeight -31, 113, 25)
	GUICtrlSetData($ComboTrier, "Trier par ordre alphabtique croissant|Trier par ordre alphabtique dcroissant|Trier par taille croissante|Trier par taille dcroissante|" & _
						"Placer les cochs en premier|Placer les cochs en dernier|Placer les supprims en dernier|Placer les supprims en premier")
	_GUICtrlComboBox_SetCurSel($ComboTrier, 0)
	GUISetCursor(2, 1, $FormListeMot) ; Curseur Classique
	;
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonAbandonner
				If ($saDico[0] <= 0) Or (_Message("C", "Voulez-vous abandonner cet anagramme ?", $FormListeMot) = 6) Then
					$saDico[0] = 0
					ExitLoop
				EndIf
			Case $ButtonValider
				; Liste des mots  passer pour la suite	des oprations
				$iNb = 0
				Dim $saListeAPasser[$saDico[0] +1]
				For $i = 1 To $saDico[0]
					If $asListeListView[$i -1][1] = 0 Then
						$iNb += 1
						$saListeAPasser[$iNb] = $asListeListView[$i -1][0]
					EndIf
				Next
				$saListeAPasser[0] = $iNb
				; Si la liste n'est pas vide, alors visualiser les anagramme
				If $iNb > 0 Then
					GUISetState(@SW_HIDE, $FormListeMot)
					If Not AnagrammeMulti_VoirListeAnagramme($saListeAPasser, $sTexteInitial) Then
						GUISetState(@SW_SHOW, $FormListeMot)
						AnagrammeMulti_GererListeMotsPossiblesListview($ListViewMot, $asListeListView)
						ControlFocus($FormListeMot, "", $ListViewMot)
						ContinueLoop
					EndIf
				Else
					_Message("I", "Vous ne pouvez passer  la suite puisqu'aucun mot n'est conserv !", $FormListeMot)
					ContinueLoop
				EndIf
				ExitLoop
			Case $ComboTrier
				GUISetCursor(15, 1, $FormListeMot) ; Curseur WAIT
				Switch _GUICtrlComboBox_GetCurSel($ComboTrier)
					Case 0
						_ArraySort($asListeListView, 0)
					Case 1
						_ArraySort($asListeListView, 1)
					Case 2
						_ArraySort($asListeListView, 0, 0, 0, 2)
					Case 3
						_ArraySort($asListeListView, 1, 0, 0, 2)
					Case 6
						_ArraySort($asListeListView, 0, 0, 0, 1)
					Case 7
						_ArraySort($asListeListView, 1, 0, 0, 1)
					Case 4
						$iNb = -$saDico[0]
						For $i = 0 To $saDico[0] -1
							If _GUICtrlListView_GetItemChecked($ListViewMot, $i) Then
								$iNb +=1
								$asListeListView[$i][3] = $iNb
							Else
								$asListeListView[$i][3] = $i
							EndIf
						Next
						_ArraySort($asListeListView, 0, 0, 0, 3)
					Case 5
						$iNb = $saDico[0]
						For $i = 0 To $saDico[0] -1
							If _GUICtrlListView_GetItemChecked($ListViewMot, $i) Then
								$iNb +=1
								$asListeListView[$i][3] = $iNb
							Else
								$asListeListView[$i][3] = $i
							EndIf
						Next
						_ArraySort($asListeListView, 0, 0, 0, 3)
				EndSwitch
				AnagrammeMulti_GererListeMotsPossiblesListview($ListViewMot, $asListeListView)
				GUISetCursor(2, 1, $FormListeMot) ; Curseur Classique
			Case $ButtonRemettre
				For $i = 0 To $saDico[0] -1
					If _GUICtrlListView_GetItemChecked($ListViewMot, $i) Then
						_GUICtrlListView_SetItemChecked($ListViewMot, $i, False)
						If $asListeListView[$i][1] <> 0 Then
							$asListeListView[$i][1] = 0
							AnagrammeMulti_GererListeMotsPossiblesListviewItem($ListViewMot, $asListeListView, $i)
						EndIf
					EndIf
				Next
			Case $ButtonSupListe
				For $i = 0 To $saDico[0] -1
					If _GUICtrlListView_GetItemChecked($ListViewMot, $i) Then
						_GUICtrlListView_SetItemChecked($ListViewMot, $i, False)
						If $asListeListView[$i][1] = 0 Then
							$asListeListView[$i][1] = 1
							AnagrammeMulti_GererListeMotsPossiblesListviewItem($ListViewMot, $asListeListView, $i)
						EndIf
					EndIf
				Next
			Case $ButtonSelCocher
				$iaIndices = _GUICtrlListView_GetSelectedIndices($ListViewMot, True)
				For $i = 1 To $iaIndices[0]
					_GUICtrlListView_SetItemChecked($ListViewMot, $iaIndices[$i], True)
				Next
			Case $ButtonSelDeCocher
				$iaIndices = _GUICtrlListView_GetSelectedIndices($ListViewMot, True)
				For $i = 1 To $iaIndices[0]
					_GUICtrlListView_SetItemChecked($ListViewMot, $iaIndices[$i], False)
				Next
		EndSwitch
		If $bDoubleClicItem Then Definition($FormListeMot, $ListViewMot)
		Sleep(30)
	WEnd
	GUIDelete($FormListeMot)
	GUISetState(@SW_SHOW, $FormJe2Mots)
	Return True
EndFunc
Func AnagrammeMulti_GererListeMotsPossiblesListview($ListViewMot, $asListeListView)
	Local $i
	_GUICtrlListView_BeginUpdate($ListViewMot)
	_GUICtrlListView_DeleteAllItems($ListViewMot)
	For $i = 0 To UBound($asListeListView)-1
		_GUICtrlListView_AddItem($ListViewMot, $asListeListView[$i][0])
		AnagrammeMulti_GererListeMotsPossiblesListviewItem($ListViewMot, $asListeListView, $i)
	Next
	_GUICtrlListView_SetItemSelected($ListViewMot, 0)
	_GUICtrlListView_EnsureVisible($ListViewMot, 0)
	_GUICtrlListView_EndUpdate($ListViewMot)
EndFunc
Func AnagrammeMulti_GererListeMotsPossiblesListviewItem($ListViewMot, $asListeListView, $iIndice)
	Local $sAV, $sAP
	If $asListeListView[$iIndice][1] = 1 Then
		_GUICtrlListView_SetItem($ListViewMot, "Pas dans cet anagramme", $iIndice, 1)
		$sAV = "("
		$sAP = ")"
	Else
		_GUICtrlListView_SetItem($ListViewMot, "", $iIndice, 1)
	EndIf
	_GUICtrlListView_SetItem($ListViewMot, $sAV & $asListeListView[$iIndice][0] & $sAP, $iIndice, 0)
EndFunc


Func AnagrammeMulti_Generer($saDico, $sTexteInitial, $FormListe, $ListView, $ButtonStop, $ProgressBar)
	Local $i, $sTemp, $bOK, $iRef, $iProgressWait = 0
	Local $iIndFinalMax = 100, $iaIndFinal[$iIndFinalMax +1]
	Local $sTexte, $iIndDico = 1, $iIndFinal = 0
	Local $saSolution[1] = [0]
	$sTexteInitial = StringLower(StringStripWS($sTexteInitial, 8))
	$sTexte = $sTexteInitial
	MouseMove(@DesktopWidth / 2, @DesktopHeight / 2)
	GUISetCursor(15, 1, $FormListe) ; Curseur WAIT
	While 1
		$iProgressWait +=1
		If ($iProgressWait > 200) And ($iaIndFinal[1] > 0) Then
			GUICtrlSetData($ProgressBar, Log($iaIndFinal[1]) / Log($saDico[0]) * 100)
			$iProgressWait = 0
			If (GUIGetMsg() = $ButtonStop) Or _IsPressed("1B", $hDllUser32) Then
				If _Message("C", "Confirmez-vous l'arrt de la recherche des autres anagrammes ?", $FormListe, True, True) = 6 Then ExitLoop
			EndIf
		EndIf
		$sTemp = $sTexte
		$bOK = True
		For $i = 1 To StringLen($saDico[$iIndDico])
			If StringInStr($sTemp, StringMid($saDico[$iIndDico], $i, 1)) = 0 Then
				$bOK = False
			Else
				$sTemp = StringReplace($sTemp, StringMid($saDico[$iIndDico], $i, 1), "", 1)
			EndIf
		Next
		If $bOK Then
			If $iIndFinal >= $iIndFinalMax Then
				_Message("E", "Trop de mots (>" & $iIndFinalMax & ") !", $FormListe, True, True)
				ExitLoop
			EndIf
			$iIndFinal += 1
			$iaIndFinal[$iIndFinal] = $iIndDico
			$sTexte = $sTemp
			If $sTexte = "" Then
				$sTemp = AnagrammeMulti_GenererChaineDeja(True, $iIndFinal, $saDico, $iaIndFinal)
				GUICtrlCreateListViewItem($sTemp, $ListView)
				_GUICtrlListView_EnsureVisible($ListView, $saSolution[0])
				$saSolution[0] += 1
				ReDim $saSolution[$saSolution[0] +1]
				$saSolution[$saSolution[0]] = $sTemp
				If $iIndFinal = 1 Then
					$iIndDico += 1
					If $iIndDico > $saDico[0] Then ExitLoop
					$iIndFinal = 0
					$sTexte = $sTexteInitial
				Else
					$iRef = $iIndFinal
					While 1
						$iIndDico = $iaIndFinal[$iIndFinal] + 1
						$iIndFinal -= 1
						If $iIndDico <= $saDico[0] Then ExitLoop
					WEnd
					For $i = $iIndFinal +1 To $iRef
						$sTexte &= $saDico[$iaIndFinal[$i]]
					Next
				EndIf
			EndIf
		Else
			If $iIndDico = $saDico[0] Then
				If $iaIndFinal[1] = $saDico[0] Then
					ExitLoop
				Else
					While 1
						$iIndFinal -= 1
						If $iIndFinal = 0 Then
							$sTexte = $sTexteInitial
							$iIndDico = $iaIndFinal[1] +1
							ExitLoop
						Else
							$iIndDico = $iaIndFinal[$iIndFinal +1] +1
							$sTexte &= $saDico[$iaIndFinal[$iIndFinal +1]]
							If $iIndDico <= $saDico[0] Then ExitLoop
						EndIf
					WEnd
				EndIf
			Else
				$iIndDico += 1
			EndIf
		EndIf
	WEnd
	GUISetCursor(2, 1, $FormListe) ; Curseur Classique
	Return $saSolution
EndFunc


Func AnagrammeMulti_GenererChaineDeja($bEspace, $iIndFinal, $saDico, $iaIndFinal)
	Local $i, $s
	For $i = 1 To $iIndFinal
		$s &= $saDico[$iaIndFinal[$i]]
		If $bEspace And ($i < $iIndFinal) Then $s &= " "
	Next
	Return $s
EndFunc


Func AnagrammeMulti_CreerListeMotsPossibles($sTexte, $hForm)
	Local $sSql, $saData, $hQuery, $i, $iNb = 0
	Local $saListe[1] = [0]
	; Sql
	$sSql = "SELECT DicoMot FROM Dico Where"
	For $i = 97 To 122 ; a to z
		StringReplace($sTexte, Chr($i), "")
		If $i > 97 Then $sSql &= " And"
		$sSql &= " DicoMot Not Like '%"
		For $j = 0 To @extended
			$sSql &= Chr($i) & "%"
		Next
		$sSql &= "'"
	Next
	Local $saListMot = StringSplit($sTexte, " ")
	For $i = 1 To $saListMot[0]
		$sSql &= " And DicoMot <> '" & StringReplace(StringLower($saListMot[$i]), "'", "''") & "'"
	Next
	$sSql &= " ORDER BY DicoMot;"
	; Passer dans le tableau
	_SQlite_Query($hDbDico, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
		$iNb += 1
		ReDim $saListe[$iNb +1]
		$saListe[$iNb] = $saData[0]
	WEnd
	_SQLite_QueryFinalize($hQuery)
	$saListe[0] = $iNb
	;
	If $iNb = 0 Then _Message("I", "Aucun mot de votre dictionnaire ne correspond  : " & $sTexte, $hForm)
	; Retourner la liste
	Return $saListe
EndFunc
#EndRegion - Anagramme-Multi --------------------------------------------------


#Region - Rglage de l'application --------------------------------------------
Func ReglagesAplli()
	Local $i, $sStrategieDeb, $sStrategieFin, $sTaille
	$i = StringInStr($sStrategieDeRecherche, "/")
	If $i > 0 Then
		$sStrategieDeb = StringLeft($sStrategieDeRecherche, $i -1)
		$sStrategieFin = StringMid($sStrategieDeRecherche, $i +1)
	Else
		$sStrategieDeb = $sStrategieDeRecherche
	EndIf
	Local $FormReglage = GUICreate("Rglages de l'application", 690, 556, 291, 126)
	GUISetBkColor(0xB8DDFD)
	GUICtrlCreateGroup(" Stratgie de recherche des dfinitions sur internet ", 8, 8, 673, 270)
	GUICtrlCreateLabel("Vous devez dfinir la stratgie utilise pour rechercher une dfinition dans les dictionnaires sur internet." & @CRLF & _
	"La difficult de recherche rside dans le fait que tous les mots ne sont pas contenus dans tous les dictionnaires et surtout ce n'est pas forcment le mot recherch qui doit ramener la dfinition mais son mot 'source'." & @CRLF & _
	"Exemple : vous recherchez la dfinition de MANGIONS, tous les dictionnaires vont vous ramener sur le mot 'source' MANGER." & @CRLF & _
	"De mme pour les pluriels, les accentus  Dans des cas plus complexes, certains dictionnaires ne retrouvent pas le mot 'source'." & @CRLF & _
	"En multipliant les recherches dans les diffrents dictionnaires la quasi-totalit des dfinitions peut tre trouve." & @CRLF & _
	"Quatre dictionnaires sont utilisables : Larousse.fr, Dictionnaire.net, Dictionnaire.TV5.org et Exionnaire.com." & @CRLF & _
	"Une aide pour reprendre une dcision sur la stratgie : Exionnaire.com est le site retournant le plus de dfinitions et Larousse.fr est le site donnant des dfinitions les plus dtailles." & @CRLF & _
	"La stratgie se dfinit en deux parties." & @CRLF & _
	"Premire partie : Liste des dictionnaires  parcourir pour trouver le mot 'source'. Ds que le mot 'source' est trouv, la deuxime partie sera excute." & @CRLF & _
	"Deuxime partie : Avec le mot 'source', la dfinition sera recherche et ramene ds quelle sera trouve." & @CRLF & _
	"Utilisez la lettre identifiant chaque dictionnaire : L= Larousse.fr, D=Dictionnaire.net, T=Dictionnaire.TV5.org et X=Exionnaire.com", 14, 32, 650, 182)
	GUICtrlSetColor(-1, 0x595959)
	GUICtrlCreateLabel("Premire partie de la stratgie - Recherche du mot 'source'", 16, 224, 280, 17)
	Local $InputStrategieDeb = GUICtrlCreateInput($sStrategieDeb, 298, 222, 50, 21)
	GUICtrlCreateLabel("Lettres possibles : L, D, T, X. Valeur par dfaut LXDT", 356, 224, 268, 17)
	GUICtrlSetColor(-1, 0x595959)
	GUICtrlCreateLabel("Seconde partie de la stratgie - Recherche de la dfinition", 16, 250, 280, 17)
	Local $InputStrategieFin = GUICtrlCreateInput($sStrategieFin, 298, 248, 50, 21)
	GUICtrlCreateLabel("Lettres possibles : L, D, T, X. Valeur par dfaut LDT", 356, 250, 268, 17)
	GUICtrlSetColor(-1, 0x595959)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup(" Les dfinitions en local ", 8, 289, 673, 113)
	GUICtrlCreateLabel("Vos dfinitions peuvent tre enregistres en local sur votre ordinateur dans la base de donnes avec la liste des mots. Elles seront raffiches plus rapidement que daller les rechercher sur internet.", 16, 313, 650, 30)
	GUICtrlSetColor(-1, 0x595959)
	Local $CheckboxEnregistrerAuto = GUICtrlCreateCheckbox("Enregistrer automatiquement chaque dfinition recherche", 16, 353, 369, 17)
	If $bEnregistrerRechercheEnBase Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $CheckboxChercherDB = GUICtrlCreateCheckbox("Rechercher chaque dfinition en local avant daller chercher sur internet", 16, 377, 369, 17)
	If $bChercherEnBase Then GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup(" Optimisation de la base de donnes ", 8, 414, 673, 65)
	GUICtrlCreateLabel("Loptimisation permet de rduire lgrement la taille de votre base de donnes. Ncessaire surtout si vous supprimez des mots de votre dictionnaire.", 16, 438, 402, 30)
	GUICtrlSetColor(-1, 0x595959)
	Local $ButtonOptimiser = GUICtrlCreateButton("Optimiser la base de donnes maintenant ", 428, 441, 219, 25)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $ButtonAbandon = GUICtrlCreateButton("Abandonner les modifications", 8, 512, 219, 25)
	Local $ButtonValidExe = GUICtrlCreateButton("Valider uniquement pour cette excution", 236, 512, 219, 25)
	Local $ButtonValidDB = GUICtrlCreateButton("Valider jusquau prochain changement", 464, 512, 219, 25)
	GUISetState(@SW_HIDE, $FormJe2Mots)
	GUISetState(@SW_SHOW, $FormReglage)
	While 1
		$sMsg = GUIGetMsg()
		Switch $sMsg
			Case $GUI_EVENT_CLOSE, $ButtonAbandon
				ExitLoop
			Case $ButtonValidExe, $ButtonValidDB
				$sStrategieDeb = StringUpper(StringStripWS(GUICtrlRead($InputStrategieDeb), 8))
				$sStrategieFin = StringUpper(StringStripWS(GUICtrlRead($InputStrategieFin), 8))
				If Not StringRegExp($sStrategieDeb, "^[LDTX]+$") Then
					_Message("E", "La premire partie de la stratgie n'est pas correctement dfinie !", $FormReglage)
					ContinueLoop
				EndIf
				If Not StringRegExp($sStrategieFin, "^[LDTX]*$") Then
					_Message("E", "La seconde partie de la stratgie n'est pas correctement dfinie !", $FormReglage)
					ContinueLoop
				EndIf
				$sStrategieDeRecherche = GUICtrlRead($InputStrategieDeb)
				If GUICtrlRead($InputStrategieFin) > "" Then $sStrategieDeRecherche &= "/" & GUICtrlRead($InputStrategieFin)
				$bEnregistrerRechercheEnBase = (GUICtrlRead($CheckboxEnregistrerAuto) = $GUI_CHECKED)
				$bChercherEnBase = (GUICtrlRead($CheckboxChercherDB) = $GUI_CHECKED)
				If $sMsg = $ButtonValidDB Then
					_DbParamMAJTexte("StrategieDeRecherche", $sStrategieDeRecherche)
					_DbParamMAJBoolean("EnregistrerRechercheEnBase", $bEnregistrerRechercheEnBase)
					_DbParamMAJBoolean("ChercherEnBase", $bChercherEnBase)
				EndIf
				ExitLoop
			Case $ButtonOptimiser
				$sTaille = _TailleFichier($scFicDB, 1)
				If $sTaille = -1 Then
					_Message("E", "Taille de la base non accessible !", $FormReglage)
				Else
					GUISetCursor(15, 1, $FormReglage) ; Curseur WAIT
					If _SQLite_Exec($hDbDico, "Vacuum") = $SQLITE_OK Then
						GUISetCursor(2) ; Curseur Classique
						_Message("I", "L'optimisation est fait" & @CRLF & "Taille avant : " & $sTaille & @CRLF & "Taille aprs : " & _TailleFichier($scFicDB, 1), $FormReglage)
					Else
						GUISetCursor(2) ; Curseur Classique
						_Message("E", "L'optimisation a rencontr une erreur !", $FormReglage)
					EndIf
				EndIf
		EndSwitch
	WEnd
	GUIDelete($FormReglage)
	GUISetState(@SW_SHOW, $FormJe2Mots)
EndFunc
#EndRegion - Rglage de l'application -----------------------------------------


#Region - Gestion de la base de donnes ---------------------------------------
Func _OuvrirDicoEtLectureParametres($hForm)
	Local Const $sbFicExiste = FileExists($scFicDB)
	Local $saData, $nDbVersion, $bMajVersionDb = False
	; Chargement de SQLite.dll
	_SQLite_Startup()
	If @error > 0 Then
		_Message("E", "SQLite.dll ne peut tre charg !", $hForm)
		Return False
	EndIf
	; Ouvrir la base
	$hDbDico = _SQLite_Open($scFicDB)
	If @error > 0 Then
		_Message("E", $scFicDB & @CRLF & "La base de donnes ne peut pas tre charge !", $hForm)
		Return False
	EndIf
	; La base de donnes existe ?
	If Not $sbFicExiste Then
		If (_SQLite_Exec($hDbDico, "CREATE TABLE Dico (DicoMot TEXT NOT NULL, CONSTRAINT [] PRIMARY KEY (DicoMot));") <> $SQLITE_OK) Or _
		   (_SQLite_Exec($hDbDico, "CREATE TABLE Definition (DefDico TEXT(1) NOT NULL, DefMot TEXT, DefCategorie TEXT, DefTexte TEXT);") <> $SQLITE_OK) Or _
		   (_SQLite_Exec($hDbDico, "CREATE TABLE Lien (LienIdDico INT NOT NULL, LienIdDef INT NOT NULL, CONSTRAINT [] PRIMARY KEY (LienIdDico, LienIdDef));") <> $SQLITE_OK) Or _
		   (_SQLite_Exec($hDbDico, "CREATE TABLE Parametre (PrmCle TEXT NOT NULL, PrmValeur TEXT, CONSTRAINT [] PRIMARY KEY (PrmCle));") <> $SQLITE_OK) Then
			_SQLite_Close($hDbDico)
			FileDelete($scFicDB)
			_Message("E", $scFicDB & @CRLF & "La base de donnes ne peut pas tre cre !", $hForm)
			Return False
		EndIf
		_SQLite_Exec($hDbDico,  "INSERT INTO Parametre (PrmCle, PrmValeur) VALUES ('Version', " & _NumVerCourt($scVersion) & ");")
	EndIf
	; La structure est-elle la bonne ?
	If _SQLite_QuerySingleRow($hDbDico, "SELECT PrmValeur FROM Parametre WHERE PrmCle = 'Version';", $saData) = $SQLITE_OK Then
		$nDbVersion = Number($saData[0])
	Else
		$nDbVersion = -1
	EndIf
	Switch $nDbVersion
		Case -1 ; Version 1.0
			If (_SQLite_Exec($hDbDico, "CREATE TABLE Definition (DefDico TEXT(1) NOT NULL, DefMot TEXT, DefCategorie TEXT, DefTexte TEXT);") <> $SQLITE_OK) Or _
			   (_SQLite_Exec($hDbDico, "CREATE TABLE Lien (LienIdDico INT NOT NULL, LienIdDef INT NOT NULL, CONSTRAINT [] PRIMARY KEY (LienIdDico, LienIdDef));") <> $SQLITE_OK) Or _
			   (_SQLite_Exec($hDbDico, "CREATE TABLE Parametre (PrmCle TEXT NOT NULL, PrmValeur TEXT, CONSTRAINT [] PRIMARY KEY (PrmCle));") <> $SQLITE_OK) Then
				_SQLite_Close($hDbDico)
				_Message("E", $scFicDB & @CRLF & "La base de donnes ne peut pas tre mise  jour !", $hForm)
				Return False
			EndIf
			$bMajVersionDb = True
			_SQLite_Exec($hDbDico,  "INSERT INTO Parametre (PrmCle, PrmValeur) VALUES ('Version', -1);")
		Case _NumVerCourt($scVersion)
			; RAF
		Case Else
			_Message("E", "Votre version de base de donnes (" & $saData[0] & ") n'est pas en accord avec celle du logiciel (" & _NumVerCourt($scVersion) & ") !", $hForm)
			Return False
	EndSwitch
	If $bMajVersionDb And _SQLite_Exec($hDbDico, "UPDATE Parametre SET PrmValeur='" & _NumVerCourt($scVersion) & "' WHERE PrmCle='Version';") <> $SQLITE_OK Then
		_Message("E", "Votre version de base de donnes ne peut pas tre mise  jour !")
		Return False
	EndIf
	; Lecture des paramtres
	$sStrategieDeRecherche = _DbParamLireTexte("StrategieDeRecherche", "LXDT/LDT")
	$bEnregistrerRechercheEnBase = _DbParamLireBoolean("EnregistrerRechercheEnBase", False)
	$bChercherEnBase = _DbParamLireBoolean("ChercherEnBase", True)
	Return True
EndFunc

Func _FermerDico()
	_SQLite_Close($hDbDico)
	_SQLite_Shutdown()
EndFunc


Func _DicoNbTousMots($bTitre)
	Local $saData, $iNb = 0, $s
	If _SQLite_QuerySingleRow($hDbDico, "SELECT Count(*) FROM Dico", $saData) = $SQLITE_OK Then $iNb = $saData[0]
	If $bTitre Then
		If $iNb = 0 Then
			$s = 'Votre dictionnaire est vide - Faire le choix "Grer votre dictionnaire"'
		Else
			$s = "Votre dictionnaire contient " & _NumMillier($iNb) & " mots"
		EndIf
		Return $s
	Else
		Return $iNb
	EndIf
EndFunc


Func _DicoNbMotsSansDefinition()
	Local $saData, $iNb = 0
	If _SQLite_QuerySingleRow($hDbDico, "SELECT Count(*) FROM Dico LEFT JOIN Lien ON Dico.ROWID = LienIdDIco WHERE LienIdDico Is Null;", $saData) = $SQLITE_OK Then _
			$iNb = $saData[0]
	Return $iNb
EndFunc


Func _DbEnregistrerDefinition($sMotInitial, $sDico, $sMotTrouve, $sCategorie, $sDefinition)
	Local $sData, $iRowIDDef, $iRowIDDico
	While 1
		; La dfinition existe dja ?
		If _SQLite_QuerySingleRow($hDbDico, "SELECT ROWID FROM Definition WHERE DefDico='" & $sDico & "' AND DefMot=" & _SQLite_Escape($sMotTrouve) & _
					" AND  DefCategorie=" & _SQLite_Escape($sCategorie) & " AND  DefTexte=" & _SQLite_Escape($sDefinition) & ";", $sData) = $SQLITE_OK Then
			$iRowIDDef = $sData[0]
			; Le ROWID du mot initial
			If _SQLite_QuerySingleRow($hDbDico, "SELECT ROWID FROM Dico WHERE DicoMot='" & $sMotInitial & "';", $sData) = $SQLITE_OK Then
				$iRowIDDico = $sData[0]
				; La dfinition est-elle dj lie au mot initial ?
				If _SQLite_QuerySingleRow($hDbDico, "SELECT ROWID FROM Lien WHERE LienIdDico=" & $iRowIDDico & " AND LienIdDef=" & $iRowIDDef & ";", $sData) <> $SQLITE_OK Then
					Return (_SQLite_Exec($hDbDico, "INSERT INTO Lien (LienIdDico, LienIdDef) VALUES (" & $iRowIDDico & ", " & $iRowIDDef & ");") = $SQLITE_OK)
				Else
					Return True
				EndIf
			Else
				Return False
			EndIf
		Else
			; Cration de la dfinition
			If _SQLite_Exec($hDbDico, "INSERT INTO Definition (DefDico, DefMot, DefCategorie, DefTexte) VALUES ('" & $sDico & "', " & _SQLite_Escape($sMotTrouve) & ", " & _
						_SQLite_Escape($sCategorie) & ", " & _SQLite_Escape($sDefinition) & ");") <> $SQLITE_OK Then Return False
		EndIf
	WEnd
EndFunc


Func _DbDefinition($sMot)
	Local $aRetour[1][3] = [[-1, "Mot non trouv en base !", ""]]
	Local $sSql, $saData, $hQuery, $i, $iNbDef = 0, $sStrategie, $sDico
	If _SQLite_QuerySingleRow($hDbDico, "SELECT ROWID FROM Dico WHERE DicoMot=" & _SQLite_Escape($sMot) & ";", $saData) = $SQLITE_OK Then
		$i = StringInStr($sStrategieDeRecherche, "/")
		If $i > 0 Then
			$sStrategie = StringMid($sStrategieDeRecherche, $i +1) & StringLeft($sStrategieDeRecherche, $i -1)
		Else
			$sStrategie = $sStrategieDeRecherche
		EndIf
		For $i = 1 To StringLen($sStrategie)
			$sDico = StringUpper(StringMid($sStrategie, $i, 1))
			$iNbDef = 0
			$sSql = "SELECT DefMot, DefCategorie, DefTexte FROM Definition INNER JOIN Lien ON Definition.ROWID = LienIdDef INNER JOIN Dico ON Dico.ROWID = LienIdDIco WHERE DicoMot=" & _
					_SQLite_Escape($sMot) & " And  DefDico='" & $sDico & "' ORDER BY Definition.ROWID ASC;"
			_SQlite_Query($hDbDico, $sSql, $hQuery)
			While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
				$iNbDef += 1
				ReDim $aRetour[$iNbDef +1][3]
				$aRetour[$iNbDef][0] = $saData[0]
				$aRetour[$iNbDef][1] = $saData[1]
				$aRetour[$iNbDef][2] = $saData[2]
			WEnd
			If $iNbDef > 0 Then
				$aRetour[0][0] = $iNbDef
				$aRetour[0][2] = StringLower($sDico)
				Switch $sDico
					Case "L"
						$aRetour[0][1] = "Larousse.fr"
					Case "D"
						$aRetour[0][1] = "Dictonnaire.net"
					Case "T"
						$aRetour[0][1] = "Dictionnaire.TV5.org"
					Case "X"
						$aRetour[0][1] = "Dictionnaire.eXionnaire.com"
					Case Else
						$aRetour[0][1] = "Quel dictionnaire ?"
				EndSwitch
				ExitLoop
			EndIf
		Next
	EndIf
	Return $aRetour
EndFunc


Func _DbSupprimerUnMot($sMot)
	Local $saData, $iRowIDDef, $iRowIDDico, $hQuery, $iNbDef
	If _SQLite_QuerySingleRow($hDbDico, "SELECT ROWID FROM Dico WHERE DicoMot=" & _SQLite_Escape($sMot) & ";", $saData) = $SQLITE_OK Then
		$iRowIDDico = $saData[0]
		If _SQLite_Exec($hDbDico, "DELETE FROM Dico WHERE ROWID=" & $iRowIDDico & ";") = $SQLITE_OK Then
			_SQlite_Query($hDbDico, "SELECT LienIdDef FROM Lien WHERE LienIdDico=" & $iRowIDDico & ";", $hQuery)
			While _SQLite_FetchData($hQuery, $saData) = $SQLITE_OK
				$iRowIDDef = $saData[0]
				If _SQLite_QuerySingleRow($hDbDico, "SELECT COUNT(*) FROM Lien WHERE LienIdDef=" & $iRowIDDef & ";", $saData) = $SQLITE_OK Then
					$iNbDef = $saData[0]
				Else
					$iNbDef = 0
				EndIf
				If $iNbDef = 1 Then _SQLite_Exec($hDbDico, "DELETE FROM Definition WHERE ROWID=" & $iRowIDDef & ";")
			WEnd
			_SQLite_QueryFinalize($hQuery)
			_SQLite_Exec($hDbDico, "DELETE FROM Lien WHERE LienIdDico=" & $iRowIDDico & ";")
			Return True
		EndIf
	Else
		Return False
	EndIf
EndFunc


Func _DbParamLireBoolean($sCle, $bDefaut)
	Local $iDefaut = 0
	If $bDefaut Then $iDefaut = 1
	Return _DbTPLireBoolean("ParamB-" & $sCle, $iDefaut)
EndFunc
Func _DbTPLireBoolean($sCle, $iDefaut = -1) ; $iDefaut : valeur par dfaut, si pas en base : 0=False, 1=True, -1=doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbDico, "SELECT PrmValeur FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return ($sData[0] = 1)
	Else
		If $iDefaut = -1 Then
			_Message("E", "", "Le paramtre '" & $sCle & "' n'est pas trouv dans la base de donnes")
			Return -1
		Else
			_DbTPInsererBoolean($sCle, $iDefaut)
			Return ($iDefaut = 1)
		EndIf
	EndIf
EndFunc
Func _DbTPInsererBoolean($sCle, $bVal)
	_SQLite_Exec($hDbDico, "INSERT INTO Parametre (PrmCle, PrmValeur) VALUES ('" & $sCle & "', '" & Number($bVal) & "');")
EndFunc
Func _DbParamMAJBoolean($sCle, $bVal)
	If Number(_DbTPLireBoolean("ParamB-" & $sCle, -1)) <> - 1 Then _
		Return (_SQLite_Exec($hDbDico, "UPDATE Parametre SET PrmValeur='" & Number($bVal) & "' WHERE PrmCle='ParamB-" & $sCle & "';") = $SQLITE_OK)
EndFunc


Func _DbParamLireNum($sCle, $dDefaut)
	Return _DbTPLireNum("ParamN-" & $sCle, $dDefaut)
EndFunc
Func _DbTPLireNum($sCle, $dDefaut = Default) ; si $dDefaut= Default => doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbDico, "SELECT PrmValeur FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return Number($sData[0])
	Else
		If $dDefaut = Default Then
			_Message("E", "Le paramtre '" & $sCle & "' n'est pas trouv dans la base de donnes")
			Return 0
		Else
			_DbTPInsererNum($sCle, $dDefaut)
			Return $dDefaut
		EndIf
	EndIf
EndFunc
Func _DbTPInsererNum($sCle, $dVal)
	_SQLite_Exec($hDbDico, "INSERT INTO Parametre (PrmCle, PrmValeur) VALUES ('" & $sCle & "', '" & $dVal & "');")
EndFunc
Func _DbTPMAJNum($sCle, $dVal)
	Return (_SQLite_Exec($hDbDico, "UPDATE Parametre SET PrmValeur='" & $dVal & "' WHERE PrmCle='" & $sCle & "';") = $SQLITE_OK)
EndFunc
Func _DbParamMAJNum($sCle, $dVal)
	 Return _DbTPMAJNum("ParamN-" & $sCle, $dVal)
EndFunc


Func _DbParamLireTexte($sCle, $sDefaut)
	Return _DbTPLireTexte("ParamT-" & $sCle, $sDefaut)
EndFunc
Func _DbTPLireTexte($sCle, $sDefaut = Default) ; si $sDefaut= Default => doit tre en base
	Local $sData
	If _SQLite_QuerySingleRow($hDbDico, "SELECT PrmValeur FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return $sData[0]
	Else
		If $sDefaut = Default Then
			_Message("E", "Le paramtre texte '" & $sCle & "' n'est pas trouv dans la base de donnes")
			Return ""
		Else
			DbTPInsererTexte($sCle, $sDefaut)
			Return $sDefaut
		EndIf
	EndIf
EndFunc
Func DbTPInsererTexte($sCle, $sVal)
	Return (_SQLite_Exec($hDbDico, "INSERT INTO Parametre (PrmCle, PrmValeur) VALUES ('" & $sCle & "', '" & $sVal & "');") = $SQLITE_OK)
EndFunc
Func _DbParamMAJTexte($sCle, $sVal)
	 Return _DbTPMAJTexte("ParamT-" & $sCle, $sVal)
EndFunc
Func _DbTPMAJTexte($sCle, $sVal)
	Local $sData
	If _SQLite_QuerySingleRow($hDbDico, "SELECT PrmValeur FROM Parametre WHERE PrmCle='" & $sCle & "';", $sData) = $SQLITE_OK Then
		Return (_SQLite_Exec($hDbDico, "UPDATE Parametre SET PrmValeur='" & $sVal & "' WHERE PrmCle='" & $sCle & "';") = $SQLITE_OK)
	Else
		Return DbTPInsererTexte($sCle, $sVal)
	EndIf
EndFunc
#EndRegion - Gestion de la base de donnes ------------------------------------


#Region - Fonctions diverses --------------------------------------------------
Func Definition($Form, $ListView)
	If Not $bDoubleClicItem Then Return
	$bDoubleClicItem = False
	Local $iaIndices = _GUICtrlListView_GetSelectedIndices($ListView, True)
	If $iaIndices[0] < 1 Then Return
	Local $saMot = StringSplit(_GUICtrlListView_GetItemText($ListView, $iaIndices[1]), " ")
	If $saMot[0] < 1 Then Return
	Local $FormDef = GUICreate("Dfinition", 667, 570, -1, -1, $WS_SIZEBOX, $WS_EX_TOOLWINDOW, $Form)
	GUISetFont(8, 800, 0, "Verdana")
	GUICtrlCreateLabel("Mot recherch", 16, 21, 86, 17)
	Local $ButtonFermer = GUICtrlCreateButton("Fermer", 450, 520, 200, 25)
	Local $ButtonClipBoard = GUICtrlCreateButton("Copier dans le presse-papier", 16, 520, 200, 25)
	Local $InputMot = GUICtrlCreateInput("", 112, 16, 257, 21)
	GUICtrlSetFont(-1, 9)
	Local $ButtonChercher = GUICtrlCreateButton("Rechercher  nouveau", 408, 15, 211, 25)
	Local $LabelDico = GUICtrlCreateLabel("", 16, 44, 634, 17)
	GUICtrlSetColor(-1, 0x3399FF)
	Local $LabelDef = GUICtrlCreateLabel("", 16, 66, 634, 445)
	GUICtrlSetBkColor(-1, 0xB8DDFD)
	GUICtrlSetColor(-1, 0x505050)
	Local $i
	GUISetState(@SW_DISABLE, $Form)
	GUISetState(@SW_SHOW, $FormDef)
	For $i = 1 To $saMot[0]
		GUICtrlSetData($InputMot, $saMot[$i])
		DefinitionAffichageEtEnregistrement($saMot[$i], $FormDef, $LabelDico, $LabelDef)
		While 1
			$sMsg = GUIGetMsg()
			Switch $sMsg
				Case $GUI_EVENT_CLOSE, $ButtonFermer
					ExitLoop
				Case $ButtonChercher
					GUICtrlSetData($LabelDef, "")
					GUICtrlSetData($LabelDico, "")
					DefinitionAffichageEtEnregistrement(GUICtrlRead($InputMot), $FormDef, $LabelDico, $LabelDef)
				Case $ButtonClipBoard
					_DefClipBoard(GUICtrlRead($InputMot), GUICtrlRead($LabelDico), GUICtrlRead($LabelDef), $FormDef)
			EndSwitch
			Sleep(20)
		WEnd
	Next
	GUIDelete($FormDef)
	GUISetState(@SW_ENABLE, $Form)
	GUISetState(@SW_SHOW, $Form)
	WinActivate($Form)
EndFunc


Func DefinitionAffichageEtEnregistrement($sMot, $FormDef, $LabelDico, $LabelDef)
	Local $i, $s = "", $bMotTrouveDb = False
	GUISetCursor(15, 1, $FormDef) ; Curseur WAIT
	Local $aRetour
	; $aRetour[][]
	; Si OK	: [0][0] = Nb de dfinitions
	;		  [0][1] = Dico utilis en toute lettre
	;		  [0][2] = Dico utilis sur une lettre (Majuscule=Internet, Minuscule=BDD)
	;		  [1][0] = Le Mot 1
	;		  [1][1] = Catgorie du Mot 1 (Verbe, Nom ...)
	;		  [1][2] = La dfinition du Mot 1
	;		  [2][0] = Le Mot 2
	;		  ...
	; Si arrt user : [0][0] = -2, [0][1] = Arrt par l'utilisateur
	; Si une erreur : [0][0] = -1, [0][1] = Texte de l'erreur
	If $bChercherEnBase Then
		$aRetour = _DbDefinition($sMot)
		If $aRetour[0][0] > 0  Then $bMotTrouveDb = True
	EndIf
	If Not $bMotTrouveDb Then $aRetour = _DicoDefinition($sStrategieDeRecherche, $sMot, $FormDef)
	If $aRetour[0][0] = -1  Then
		GUICtrlSetData($LabelDico, $sMot & " : " & $aRetour[0][1])
		GUICtrlSetColor($LabelDico, 0xF82323)
	Else
		GUICtrlSetData($LabelDico, _DixNombresLettre($aRetour[0][0]) & " dfinition" & _Pluriel($aRetour[0][0]) & " du mot " & $sMot & " sur " & $aRetour[0][1])
		For $i = 1 To $aRetour[0][0]
			$s &= $aRetour[$i][0] & @TAB  & "(" & $aRetour[$i][1] & ")" & @CRLF & $aRetour[$i][2] & @CRLF & @CRLF
			If $bEnregistrerRechercheEnBase And Not $bMotTrouveDb Then _DbEnregistrerDefinition($sMot, $aRetour[0][2], $aRetour[$i][0], $aRetour[$i][1], $aRetour[$i][2])
		Next
		If StringIsLower($aRetour[0][2]) Then
			GUICtrlSetColor($LabelDico, 0x5CB066)
		Else
			GUICtrlSetColor($LabelDico, 0x3399FF)
		EndIf
	EndIf
	GUICtrlSetData($LabelDef, $s)
	GUISetState(@SW_SHOW, $FormDef)
	GUISetCursor(2, 1, $FormDef) ; Curseur Classique
EndFunc


Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	If StringLeft(ControlGetFocus("[ACTIVE]", ""), 11) = "SysListView" Then
		; Les traitements ne sont pas faits ici pour permettre de terminer le WM_NOTIFY
		If DllStructGetData(DllStructCreate($tagNMHDR, $ilParam), "Code") = $NM_DBLCLK Then $bDoubleClicItem = True
	EndIf
	Return $GUI_RUNDEFMSG
	$iwParam = $iwParam + $iMsg + $hWnd ; Ligne bidon pour viter au compilateur de mettre une alerte : declared, but not used in func.
EndFunc


Func _TableauEnUnTexte($sTexteColonne, $saListe)
	Local $i, $s = $sTexteColonne & @CRLF
	For $i = 1 To $saListe[0] -1
		$s &= $saListe[$i] & @CRLF
	Next
	Return $s & $saListe[$saListe[0]]
EndFunc


Func _ListViewEnUnTexte($sTexteColonne, $Listview)
	Local $i, $s = $sTexteColonne & @CRLF
	For $i = 0 To _GUICtrlListView_GetItemCount($Listview) -2
		$s &= _GUICtrlListView_GetItemText($Listview, $i) & @CRLF
	Next
	Return $s & _GUICtrlListView_GetItemText($Listview, _GUICtrlListView_GetItemCount($Listview) -1)
EndFunc


Func _ListViewClipPut($sTexteColonne, $ListView, $Form)
	If ClipPut(_ListViewEnUnTexte($sTexteColonne, $ListView)) Then
		_Message("I", "La liste a t copie dans votre presse-papier", $Form)
	Else
		_Message("E", "ERREUR : La liste n'a pas t copie dans votre presse-papier !!!", $Form)
	EndIf
EndFunc


Func _ListViewSaveTxt($sTexteColonne, $sFichierDef, $ListView, $Form)
	Local $hFile, $bOK, $sFichier
	$sFichier = FileSaveDialog("Nom du fichier", "", "Txt (*.txt)|Tous les fichiers (*.*)", 18, $sFichierDef, $Form)
	If (@error = 0) And ($sFichier <> "") Then
		$bOK = False
		$hFile = FileOpen($sFichier, 10)
		If $hFile <> -1 Then
			$bOK = FileWrite($hFile, _ListViewEnUnTexte($sTexteColonne, $ListView))
			FileClose($hFile)
		EndIf
		If $bOK Then
			_Message("I", "La liste a t copie dans le fichier " & $sFichier, $Form)
		Else
			_Message("E", "ERREUR : La liste n'a pas t copie dans le fichier " & $sFichier, $Form)
		EndIf
	EndIf
EndFunc


Func _DefClipBoard($sMot, $sLabelDico, $sLabelDef, $Form)
	If ClipPut($sMot & @CRLF & $sLabelDico & @CRLF & $sLabelDef) Then
		_Message("I", "La dfinition a t copie dans votre presse-papier", $Form)
	Else
		_Message("E", "ERREUR : La dfinition n'a pas t copie dans votre presse-papier !!!", $Form)
	EndIf
EndFunc


Func _EspaceBureau($iIndiceUnique = -1)
    Local $iEspaceBureau[4]
    Local $stRect = DllStructCreate("long left;long top;long right;long bottom")
    Local $iResult = _WinAPI_SystemParametersInfo(48, 0, DllStructGetPtr($stRect), 0)
    If $iResult Then
        $iEspaceBureau[0] = DllStructGetData($stRect, "left")
        $iEspaceBureau[1] = DllStructGetData($stRect, "top")
        $iEspaceBureau[2] = DllStructGetData($stRect, "right")
        $iEspaceBureau[3] = DllStructGetData($stRect, "bottom")
    Else
        $iEspaceBureau[0] = 0
        $iEspaceBureau[1] = 0
        $iEspaceBureau[2] = @DesktopWidth
        $iEspaceBureau[3] = @DesktopHeight
    EndIf
	If ($iIndiceUnique = -1) Or ($iIndiceUnique < 0) Or ($iIndiceUnique > 3) Then
		Return $iEspaceBureau
	Else
		Return $iEspaceBureau[$iIndiceUnique]
	EndIf
EndFunc


Func _Message($cType, $sMessage, $hForm = 0, $bSourisWait = False, $bSourisCentre = False)
	Local $iRetour
	If $bSourisWait Then GUISetCursor(2, 1, $hForm) ; Curseur Classique
	Switch $cType
		Case "C"
			$iRetour = MsgBox(8484, "Confirmation", $sMessage, 0, $hForm)
		Case "I"
			MsgBox(8256, "Information", $sMessage, 0, $hForm)
		Case "E"
			MsgBox(4112, "Erreur", $sMessage, 0, $hForm)
	EndSwitch
	Sleep(100)
	If $bSourisCentre Then MouseMove(@DesktopWidth / 2, @DesktopHeight / 2)
	If $bSourisWait Then GUISetCursor(15, 1, $hForm) ; Curseur WAIT
	Return $iRetour
EndFunc


Func _DixNombresLettre($iVal)
	Local $s
	Switch $iVal
		Case -10 To 0
			$s = "Aucune"
		Case 1
			$s = "Une"
		Case 2
			$s = "Deux"
		Case 3
			$s = "Trois"
		Case 4
			$s = "Quatre"
		Case 5
			$s = "Cinq"
		Case 6
			$s = "Six"
		Case 7
			$s = "Sept"
		Case 8
			$s = "Huit"
		Case 9
			$s = "Neuf"
		Case 10
			$s = "Dix"
		Case Else
			$s = $iVal
	EndSwitch
	Return $s
EndFunc


Func _Pluriel($iNb)
	If $iNb > 1 Then
		Return "s"
	Else
		Return ""
	EndIf
EndFunc


Func _NumMillier($iVal)
	If $iVal > 999 Then
		Return StringTrimRight($iVal, 3) & " " & StringRight($iVal, 3)
	Else
		Return $iVal
	EndIf
EndFunc


Func _NumVersion($sScript)
	If @Compiled Then Return FileGetVersion($sScript)
	Local $s, $hFile = FileOpen($sScript)
	If $hFile <> -1 Then
		While 1
			$s = FileReadLine($hFile)
			If @error = -1 Then ExitLoop
			If StringLeft($s, 32) = "#AutoIt3Wrapper_Res_Fileversion=" Then Return StringStripWS(StringMid($s, 33), 8)
		WEnd
	EndIf
	Return "0.0.0.0"
EndFunc


Func _TailleFichier($sNomComplet, $iFormat = 0)
	Local $dTaille, $iUnite = 0, $iDec
	Local Const $scUnite[4] = ["Octets", "Ko", "Mo", "Go"]
	$dTaille = FileGetSize($sNomComplet)
	If @error = 1 Then Return - 1
	Switch $iFormat
		Case 0
			Return $dTaille
		Case 1
			While $dTaille > 1024
				$dTaille = $dTaille / 1024
				$iUnite += 1
			WEnd
			For $iDec = 0 To 3
				If stringlen(String(Round($dTaille, $iDec))) > 3 Then
					$dTaille = Round($dTaille, $iDec)
					ExitLoop
				EndIf
			Next
			Return $dTaille & " " & $scUnite[$iUnite]
	EndSwitch
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction retournant le numro de version sur 2 positions
; IN  $sVer : Numro de version sur 4 positions ou moins
; OUT Numro de version sur 2 positions
;--------------------------------------------------------------------------------------------------
Func _NumVerCourt($sVer)
	Local $i = StringInStr($sVer, ".", 0, 2) -1
	If $i > 0 Then
		Return String(StringLeft($sVer, $i))
	Else
		If StringInStr($sVer, ".") = 0 Then
			Return String($sVer & ".0")
		Else
			Return String($sVer)
		EndIf
	EndIf
EndFunc


; Auteur=weaponx Voir=http://www.autoitscript.com/forum/topic/71625-colour-gradient-algorithm/
Func _VGradientFill($hGrapgic, $iLeft, $iTop, $iWidth, $iHeight, $aiTopColorHSL, $aiBottomColorHSL)
    Local $Y, $red, $green, $blue, $color[3], $iMaxY = $iHeight + $iTop
    $color[0] = ($aiTopColorHSL[0] - $aiBottomColorHSL[0]) / $iMaxY
    $color[1] = ($aiTopColorHSL[1] - $aiBottomColorHSL[1]) / $iMaxY
    $color[2] = ($aiTopColorHSL[2] - $aiBottomColorHSL[2]) / $iMaxY
    For $Y = $iTop To $iMaxY
        $red = $aiTopColorHSL[0] - ($Y * $color[0])
        $green = $aiTopColorHSL[1] - ($Y * $color[1])
        $blue = $aiTopColorHSL[2] - ($Y * $color[2])
        _DrawLine($hGrapgic, $iLeft, $Y, $iLeft + $iWidth, $Y, Dec(Hex(Floor($Blue), 2) & Hex(Floor($Green), 2) & Hex(Floor($Red), 2)))
    Next
EndFunc
Func _DrawLine($hGrapgic, $X1, $Y1, $X2, $Y2, $COLOR)
    GUICtrlSetGraphic($hGrapgic, $GUI_GR_COLOR, $COLOR)
    GUICtrlSetGraphic($hGrapgic, $GUI_GR_MOVE, $X1, $Y1)
    GUICtrlSetGraphic($hGrapgic, $GUI_GR_LINE, $X2, $Y2)
EndFunc
#EndRegion - Fonctions diverses -----------------------------------------------